
(in-package :traps)             ; 
; Created: Monday, January 14, 1991 at 4:56 PM
;     Files.p
;     Pascal Interface to the Macintosh Libraries
; 
;         Copyright Apple Computer, Inc.    1985-1990
;         All rights reserved
; 

;;;;;;;;;;;;;
;
; Modification History
;

; 04/28/93 mwp Release
; 06/02/92 bill ioTaginfo -> unsigned
; 06/01/92 bill ioVFrBlk -> unsigned (Duncan Smith)
; 05/14/92 bill Fix Moon's bug with numVersion record.
; 2/18/92 bill  Engber's fixes to _getfsqhdr, _getdrvqhdr, _getvcbqhdr
; ------------- 2.0f2
; 10/31/91 bill All hail the return of _getfsqhdr, _getdrvqhdr, & _getvcbqhdr
; 08/23/91 bill Typos in _AddDrive & _FSClose
;

; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED UsingFiles
; $SETC UsingFiles := 1

; $I+
; $SETC FilesIncludes := UsingIncludes
; $SETC UsingIncludes := 1
; $IFC UNDEFINED UsingTypes

(require-interface 'TYPES)      ; $I $$Shell(PInterfaces)Types.p
; $ENDC
; $IFC UNDEFINED UsingOSUtils

(require-interface 'OSUTILS)    ; $I $$Shell(PInterfaces)OSUtils.p
; $ENDC
; $IFC UNDEFINED UsingSegLoad

(require-interface 'SEGLOAD)    ; $I $$Shell(PInterfaces)SegLoad.p
; $ENDC
; $SETC UsingIncludes := FilesIncludes

;  Finder Constants 
(defconstant $fsAtMark 0)
(defconstant $fOnDesk 1)
(defconstant $fsCurPerm 0)
(defconstant $fHasBundle 8192)
(defconstant $fsRdPerm 1)
(defconstant $fInvisible 16384)
(defconstant $fTrash -3)
(defconstant $fsWrPerm 2)
(defconstant $fDesktop -2)
(defconstant $fsRdWrPerm 3)
(defconstant $fDisk 0)
(defconstant $fsRdWrShPerm 4)
(defconstant $fsFromStart 1)
(defconstant $fsFromLEOF 2)
(defconstant $fsFromMark 3)
(defconstant $rdVerify 64)
(defconstant $ioDirFlg 3)       ;  see IM IV-125 
(defconstant $ioDirMask #x10)
(defconstant $fsRtParID 1)
(defconstant $fsRtDirID 2)

;  masks for SpecBits values 
(defconstant $fsSBPartialName 1)
(defconstant $fsSBFullName 2)
(defconstant $fsSBFlAttrib 4)
(defconstant $fsSBFlFndrInfo 8)
(defconstant $fsSBFlLgLen 32)
(defconstant $fsSBFlPyLen 64)
(defconstant $fsSBFlRLgLen 128)
(defconstant $fsSBFlRPyLen 256)
(defconstant $fsSBFlCrDat 512)
(defconstant $fsSBFlMdDat 1024)
(defconstant $fsSBFlBkDat 2048)
(defconstant $fsSBFlXFndrInfo 4096)
(defconstant $fsSBFlParID 8192)
(defconstant $fsSBNegate 16384)
(defconstant $fsSBDrUsrWds 8)
(defconstant $fsSBDrNmFls 16)
(defconstant $fsSBDrCrDat 512)
(defconstant $fsSBDrMdDat 1024)
(defconstant $fsSBDrBkDat 2048)
(defconstant $fsSBDrFndrInfo 4096)
(defconstant $fsSBDrParID 8192)

;  vMAttrib (GetVolParms) bit position constants 
(defconstant $bLimitFCBs 31)
(defconstant $bLocalWList 30)
(defconstant $bNoMiniFndr 29)
(defconstant $bNoVNEdit 28)
(defconstant $bNoLclSync 27)
(defconstant $bTrshOffLine 26)
(defconstant $bNoSwitchTo 25)
(defconstant $bNoDeskItems 20)
(defconstant $bNoBootBlks 19)
(defconstant $bAccessCntl 18)
(defconstant $bNoSysDir 17)
(defconstant $bHasExtFSVol 16)
(defconstant $bHasOpenDeny 15)
(defconstant $bHasCopyFile 14)
(defconstant $bHasMoveRename 13)
(defconstant $bHasDesktopMgr 12)
(defconstant $bHasShortName 11)
(defconstant $bHasFolderLock 10)
(defconstant $bHasPersonalAccessPrivileges 9)
(defconstant $bHasUserGroupList 8)
(defconstant $bHasCatSearch 7)
(defconstant $bHasFileIDs 6)
(defconstant $bHasBTreeMgr 5)
(defconstant $bHasBlankAccessPrivileges 4)

;  Desktop Database icon Constants 
(defconstant $kLargeIcon 1)
(defconstant $kLarge4BitIcon 2)
(defconstant $kLarge8BitIcon 3)
(defconstant $kSmallIcon 4)
(defconstant $kSmall4BitIcon 5)
(defconstant $kSmall8BitIcon 6)

(defconstant $kLargeIconSize 256)
(defconstant $kLarge4BitIconSize 512)
(defconstant $kLarge8BitIconSize 1024)
(defconstant $kSmallIconSize 64)
(defconstant $kSmall4BitIconSize 128)
(defconstant $kSmall8BitIconSize 256)

;  foreign privilege model identifiers 
(defconstant $fsUnixPriv 1)

;  Version Release Stage Codes 
(defconstant $developStage #x20)
(defconstant $alphaStage #x40)
(defconstant $betaStage #x60)
(defconstant $finalStage #x80)

;  Authentication Constants 
(defconstant $kNoUserAuthentication 1)
(defconstant $kPassword 2)
(defconstant $kEncryptPassword 3)
(defconstant $kTwoWayEncryptPassword 6)

(def-mactype :cinfotype (find-mactype :unsigned-byte))
(defconstant $hFileInfo 0)
(defconstant $dirInfo 1)

(defrecord FXInfo 
   (fdIconID :signed-integer)   ;  Icon ID
   (fdUnused (:array :signed-integer 3)); unused but reserved 6 bytes
   (fdScript :signed-byte)      ;  Script flag and number 
   (fdXFlags :signed-byte)
   (fdComment :signed-integer)  ;  Comment ID
   (fdPutAway :signed-long)     ;  Home Dir ID
   )

(defrecord DInfo 
   (frRect :rect)               ; folder rect
   (frFlags :signed-integer)    ; Flags
   (frLocation :point)          ; folder location
   (frView :signed-integer)     ; folder view
   )

(defrecord DXInfo 
   (frScroll :point)            ; scroll position
   (frOpenChain :signed-long)   ; DirID chain of open folders
   (frScript :signed-byte)      ;  Script flag and number 
   (frXFlags :signed-byte)
   (frComment :signed-integer)  ; comment
   (frPutAway :signed-long)     ; DirID
   )

(defrecord GetVolParmsInfoBuffer 
   (vMVersion :signed-integer)  ; version number
   (vMAttrib :signed-long)      ; bit vector of attributes (see vMAttrib constants)
   (vMLocalHand :handle)        ; handle to private data
   (vMServerAdr :signed-long)   ; AppleTalk server address or zero
   (vMVolumeGrade :signed-long) ; approx. speed rating or zero if unrated
   (vMForeignPrivID :signed-integer); foreign privilege model supported or zero if none
   )

(def-mactype :cinfopbptr (find-mactype :pointer))
(defrecord CInfoPBRec 
   (qLink (:pointer :qelem))
   (qType :signed-integer)
   (ioTrap :signed-integer)
   (ioCmdAddr :pointer)
   (ioCompletion :pointer)
   (ioResult :signed-integer)
   (ioNamePtr (:pointer (:string 255)))
   (ioVRefNum :signed-integer)
   (ioFRefNum :signed-integer)
   (ioFVersNum :signed-byte)
   (filler1 :signed-byte)
   (ioFDirIndex :signed-integer)
   (ioFlAttrib :signed-byte)
   (filler2 :signed-byte)
   (:variant 

      ((ioFlFndrInfo :finfo)
      (ioDirID :signed-long)
      (ioFlStBlk :signed-integer)
      (ioFlLgLen :signed-long)
      (ioFlPyLen :signed-long)
      (ioFlRStBlk :signed-integer)
      (ioFlRLgLen :signed-long)
      (ioFlRPyLen :signed-long)
      (ioFlCrDat :signed-long)
      (ioFlMdDat :signed-long)
      (ioFlBkDat :signed-long)
      (ioFlXFndrInfo :fxinfo)
      (ioFlParID :signed-long)
      (ioFlClpSiz :signed-long))

      ((ioDrUsrWds :dinfo)
      (ioDrDirID :signed-long)
      (ioDrNmFls :signed-integer)
      (filler3 (:array :signed-integer 9))
      (ioDrCrDat :signed-long)
      (ioDrMdDat :signed-long)
      (ioDrBkDat :signed-long)
      (ioDrFndrInfo :dxinfo)
      (ioDrParID :signed-long))
      ))

(defrecord CatPositionRec 
   (initialize :signed-long)
   (priv (:array :signed-integer 6))
   )

(def-mactype :fsspecptr (find-mactype :pointer))
(def-mactype :fsspechandle (find-mactype :handle))
(defrecord (FSSpec :handle) 
   (vRefNum :signed-integer)
   (parID :signed-long)
   (name (:string 63))
   )

(def-mactype :fsspecarrayptr (find-mactype :pointer))
(def-mactype :fsspecarrayhandle (find-mactype :handle))

(DEFRECORD (FSSPECARRAY :HANDLE) (ARRAY (ARRAY :FSSPEC 1)))

;     The following are structures to be filled out with the _GetVolMountInfo call
;     and passed back into the _VolumeMount call for external file system mounts.

(def-mactype :volumetype (find-mactype :ostype))

(defconstant $AppleShareMediaType :|afpm|);  the signature for AppleShare 

(def-mactype :volmountinfoptr (find-mactype :pointer))
(defrecord VolMountInfoHeader 
   (length :signed-integer)     ;  length of location data (including self) 
   (media :ostype)              ;  type of media. Variable length data follows 
   )

(def-mactype :afpvolmountinfoptr (find-mactype :pointer))
(defrecord AFPVolMountInfo 
   (length :signed-integer)     ;  length of location data (including self) 
   (media :ostype)              ;  type of media 
   (flags :signed-integer)      ;  bits for no messages, no reconnect 
   (nbpInterval :signed-byte)   ;  NBP Interval parameter (IM2, p.322) 
   (nbpCount :signed-byte)      ;  NBP Interval parameter (IM2, p.322) 
   (uamType :signed-integer)    ;  User Authentication Method 
   (zoneNameOffset :signed-integer);  short positive offset from start of struct to Zone Name 
   (serverNameOffset :signed-integer);  offset to pascal Server Name string 
   (volNameOffset :signed-integer);  offset to pascal Volume Name string 
   (userNameOffset :signed-integer);  offset to pascal User Name string 
   (userPasswordOffset :signed-integer);  offset to pascal User Password string 
   (volPasswordOffset :signed-integer);  offset to pascal Volume Password string 
   (AFPData (:array :character 144));  variable length data may follow 
   )

(def-mactype :dtpbptr (find-mactype :pointer))
(defrecord DTPBRec 
   (qLink (:pointer :qelem))
   (qType :signed-integer)
   (ioTrap :signed-integer)
   (ioCmdAddr :pointer)
   (ioCompletion :pointer)
   (ioResult :signed-integer)
   (ioNamePtr (:pointer (:string 255)))
   (ioVRefNum :signed-integer)
   (ioDTRefNum :signed-integer)
   (ioIndex :signed-integer)
   (ioTagInfo :unsigned-long)
   (ioDTBuffer :pointer)
   (ioDTReqCount :signed-long)
   (ioDTActCount :signed-long)
   (filler1 :signed-byte)
   (ioIconType :signed-byte)
   (filler2 :signed-integer)
   (ioDirID :signed-long)
   (ioFileCreator :ostype)
   (ioFileType :ostype)
   (ioFiller3 :signed-long)
   (ioDTLgLen :signed-long)
   (ioDTPyLen :signed-long)
   (ioFiller4 (:array :signed-integer 14))
   (ioAPPLParID :signed-long)
   )

(def-mactype :hparmblkptr (find-mactype :pointer))
(defrecord HParamBlockRec 
   (qLink (:pointer :qelem))
   (qType :signed-integer)
   (ioTrap :signed-integer)
   (ioCmdAddr :pointer)
   (ioCompletion :pointer)
   (ioResult :signed-integer)
   (ioNamePtr (:pointer (:string 255)))
   (ioVRefNum :signed-integer)
   (:variant 

      ((ioRefNum :signed-integer)
      (ioVersNum :signed-byte)
      (ioPermssn :signed-byte)
      (ioMisc :pointer)
      (ioBuffer :pointer)
      (ioReqCount :signed-long) ; size of buffer area
      (ioActCount :signed-long) ; length of vol parms data
      (ioPosMode :signed-integer)
      (ioPosOffset :signed-long))

      ((ioFRefNum :signed-integer)
      (ioFVersNum :signed-byte)
      (filler1 :signed-byte)
      (ioFDirIndex :signed-integer)
      (ioFlAttrib :signed-byte)
      (ioFlVersNum :signed-byte)
      (ioFlFndrInfo :finfo)
      (ioDirID :signed-long)
      (ioFlStBlk :signed-integer)
      (ioFlLgLen :signed-long)
      (ioFlPyLen :signed-long)
      (ioFlRStBlk :signed-integer)
      (ioFlRLgLen :signed-long)
      (ioFlRPyLen :signed-long)
      (ioFlCrDat :signed-long)
      (ioFlMdDat :signed-long))

      ((filler2 :signed-long)
      (ioVolIndex :signed-integer)
      (ioVCrDate :signed-long)
      (ioVLsMod :signed-long)
      (ioVAtrb :signed-integer)
      (ioVNmFls :signed-integer)
      (ioVBitMap :signed-integer)
      (ioAllocPtr :signed-integer)
      (ioVNmAlBlks :signed-integer)
      (ioVAlBlkSiz :signed-long)
      (ioVClpSiz :signed-long)
      (ioAlBlSt :signed-integer)
      (ioVNxtCNID :signed-long)
      (ioVFrBlk :unsigned-integer)
      (ioVSigWord :signed-integer)
      (ioVDrvInfo :signed-integer)
      (ioVDRefNum :signed-integer)
      (ioVFSID :signed-integer)
      (ioVBkUp :signed-long)
      (ioVSeqNum :signed-integer)
      (ioVWrCnt :signed-long)
      (ioVFilCnt :signed-long)
      (ioVDirCnt :signed-long)
      (ioVFndrInfo (:array :signed-long 8)))

      ((filler3 :signed-integer)
      (ioDenyModes :signed-integer); access rights data
      (filler4 :signed-integer)
      (filler5 :signed-byte)
      (ioACUser :signed-byte)   ; access rights for directory only
      (filler6 :signed-long)
      (ioACOwnerID :signed-long); owner ID
      (ioACGroupID :signed-long); group ID
      (ioACAccess :signed-long)); access rights

      ((filler7 :signed-integer)
      (ioObjType :signed-integer); function code
      (ioObjNamePtr :pointer)   ; ptr to returned creator/group name
      (ioObjID :signed-long))   ; creator/group ID

      ((ioDstVRefNum :signed-integer); destination vol identifier
      (filler8 :signed-integer)
      (ioNewName :pointer)      ; ptr to destination pathname
      (ioCopyName :pointer)     ; ptr to optional name
      (ioNewDirID :signed-long)); destination directory ID

      ((filler9 :signed-integer)
      (ioWDIndex :signed-integer)
      (ioWDProcID :signed-long)
      (ioWDVRefNum :signed-integer)
      (filler10 :signed-integer)
      (filler11 :signed-long)
      (filler12 :signed-long)
      (filler13 :signed-long)
      (ioWDDirID :signed-long))

      ((filler14 :signed-long)
      (ioDestNamePtr (:pointer (:string 255)))
      (filler15 :signed-long)
      (ioDestDirID :signed-long)
      (filler16 :signed-long)
      (filler17 :signed-long)
      (ioSrcDirID :signed-long)
      (filler18 :signed-integer)
      (ioFileID :signed-long))

      ((ioMatchPtr (:pointer :fsspecarray)); match array
      (ioReqMatchCount :signed-long); maximum allowable matches
      (ioActMatchCount :signed-long); actual match count
      (ioSearchBits :signed-long); search criteria selector
      (ioSearchInfo1 (:pointer :cinfopbrec)); search values and range lower bounds
      (ioSearchInfo2 (:pointer :cinfopbrec)); search values and range upper bounds
      (ioSearchTime :signed-long); length of time to run the search
      (ioCatPosition :catpositionrec); current position in the catalog
      (ioOptBuffer :pointer)    ; optional performance enhancement buffer
      (ioOptBufSize :signed-long)); length of buffer pointed to by ioOptBuffer

      ((filler21 :signed-long)
      (filler22 :signed-long)
      (ioForeignPrivBuffer :pointer)
      (ioForeignPrivReqCount :signed-long)
      (ioForeignPrivActCount :signed-long)
      (filler23 :signed-long)
      (ioForeignPrivDirID :signed-long)
      (ioForeignPrivInfo1 :signed-long)
      (ioForeignPrivInfo2 :signed-long)
      (ioForeignPrivInfo3 :signed-long)
      (ioForeignPrivInfo4 :signed-long))
      ))

(def-mactype :cmovepbptr (find-mactype :pointer))
(defrecord CMovePBRec 
   (qLink (:pointer :qelem))
   (qType :signed-integer)
   (ioTrap :signed-integer)
   (ioCmdAddr :pointer)
   (ioCompletion :pointer)
   (ioResult :signed-integer)
   (ioNamePtr (:pointer (:string 255)))
   (ioVRefNum :signed-integer)
   (filler1 :signed-long)
   (ioNewName (:pointer (:string 255)))
   (filler2 :signed-long)
   (ioNewDirID :signed-long)
   (filler3 (:array :signed-long 2))
   (ioDirID :signed-long)
   )

(def-mactype :wdpbptr (find-mactype :pointer))
(defrecord WDPBRec 
   (qLink (:pointer :qelem))
   (qType :signed-integer)
   (ioTrap :signed-integer)
   (ioCmdAddr :pointer)
   (ioCompletion :pointer)
   (ioResult :signed-integer)
   (ioNamePtr (:pointer (:string 255)))
   (ioVRefNum :signed-integer)
   (filler1 :signed-integer)
   (ioWDIndex :signed-integer)
   (ioWDProcID :signed-long)
   (ioWDVRefNum :signed-integer)
   (filler2 (:array :signed-integer 7))
   (ioWDDirID :signed-long)
   )

(def-mactype :fcbpbptr (find-mactype :pointer))
(defrecord FCBPBRec 
   (qLink (:pointer :qelem))
   (qType :signed-integer)
   (ioTrap :signed-integer)
   (ioCmdAddr :pointer)
   (ioCompletion :pointer)
   (ioResult :signed-integer)
   (ioNamePtr (:pointer (:string 255)))
   (ioVRefNum :signed-integer)
   (ioRefNum :signed-integer)
   (filler :signed-integer)
   (ioFCBIndx :signed-integer)
   (filler1 :signed-integer)
   (ioFCBFlNm :signed-long)
   (ioFCBFlags :signed-integer)
   (ioFCBStBlk :signed-integer)
   (ioFCBEOF :signed-long)
   (ioFCBPLen :signed-long)
   (ioFCBCrPs :signed-long)
   (ioFCBVRefNum :signed-integer)
   (ioFCBClpSiz :signed-long)
   (ioFCBParID :signed-long)
   )

; Numeric version part of 'vers' resource
(defrecord NumVersion 
   (:variant 

      ((majorRev :signed-byte)  ; 1st part of version number in BCD
       (minorAndBugFixRev :unsigned-byte)       ; we don't support nibbles (yet).
;      (minorRev :unsigned-byte) ; 2nd part is 1 nibble in BCD
;      (bugFixRev :unsigned-byte); 3rd part is 1 nibble in BCD
      (stage :signed-byte)      ; stage code: dev, alpha, beta, final
      (nonRelRev :signed-byte)) ; revision level of non-released version

      ((version :signed-long))  ; to use all 4 fields at one time
      ))

; 'vers' resource format
(def-mactype :versrecptr (find-mactype :pointer))
(def-mactype :versrechndl (find-mactype :handle))
(defrecord (VersRec :handle) 
   (numericVersion :numversion) ; encoded version number
   (countryCode :signed-integer); country code from intl utilities
   (shortVersion (:string 255)) ; version number string - worst case
   (reserved (:string 255))     ; longMessage string packed after shortVersion
   )


(deftrap _pbopen ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA000 :a0 paramblock))

(deftrap _open ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA000 :a0 paramblock))

(deftrap _pbclose ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA001 :a0 paramblock))

(deftrap _close ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA001 :a0 paramblock))

(deftrap _pbread ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA002 :a0 paramblock))

(deftrap _read ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA002 :a0 paramblock))

(deftrap _pbwrite ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA003 :a0 paramblock))

(deftrap _write ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA003 :a0 paramblock))

(deftrap _pbgetvinfo ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA007 :a0 paramblock))

(deftrap _getvinfo ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA007 :a0 paramblock))

(deftrap _pbgetvol ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA014 :a0 paramblock))

(deftrap _getvol ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA014 :a0 paramblock))

(deftrap _pbsetvol ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA015 :a0 paramblock))

(deftrap _setvol ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA015 :a0 paramblock))

(deftrap _pbflushvol ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA013 :a0 paramblock))

(deftrap _flushvol ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA013 :a0 paramblock))

(deftrap _pbcreate ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA008 :a0 paramblock))

(deftrap _create ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA008 :a0 paramblock))

(deftrap _pbdelete ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA009 :a0 paramblock))

(deftrap _delete ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA009 :a0 paramblock))

(deftrap _pbopendf ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA060 :a0 paramblock :d0 26))

(deftrap _opendf ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA060 :a0 paramblock :d0 26))

(deftrap _pbopenrf ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA00A :a0 paramblock))

(deftrap _openrf ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA00A :a0 paramblock))

(deftrap _pbrename ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA00B :a0 paramblock))

(deftrap _rename ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA00B :a0 paramblock))

(deftrap _pbgetfinfo ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA00C :a0 paramblock))

(deftrap _getfinfo ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA00C :a0 paramblock))

(deftrap _pbsetfinfo ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA00D :a0 paramblock))

(deftrap _setfinfo ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA00D :a0 paramblock))

(deftrap _pbsetflock ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA041 :a0 paramblock))

(deftrap _setflock ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA041 :a0 paramblock))

(deftrap _pbrstflock ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA042 :a0 paramblock))

(deftrap _rstflock ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA042 :a0 paramblock))

(deftrap _pbsetfvers ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA043 :a0 paramblock))

(deftrap _setfvers ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA043 :a0 paramblock))

(deftrap _pballocate ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA010 :a0 paramblock))

(deftrap _allocate ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA010 :a0 paramblock))

(deftrap _pbgeteof ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA011 :a0 paramblock))

(deftrap _geteof ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA011 :a0 paramblock))

(deftrap _pbseteof ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA012 :a0 paramblock))

(deftrap _seteof ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA012 :a0 paramblock))

(deftrap _pbgetfpos ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA018 :a0 paramblock))

(deftrap _getfpos ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA018 :a0 paramblock))

(deftrap _pbsetfpos ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA044 :a0 paramblock))

(deftrap _setfpos ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA044 :a0 paramblock))

(deftrap _pbflushfile ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA045 :a0 paramblock))

(deftrap _flushfile ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA045 :a0 paramblock))

(deftrap _pbmountvol ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA00F :a0 paramblock))

(deftrap _mountvol ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA00F :a0 paramblock))

(deftrap _pbunmountvol ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA00E :a0 paramblock))

(deftrap _unmountvol ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA00E :a0 paramblock))

(deftrap _pbeject ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA017 :a0 paramblock))

(deftrap _eject ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA017 :a0 paramblock))

(deftrap _pboffline ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA035 :a0 paramblock))

(deftrap _offline ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA035 :a0 paramblock))

(deftrap _pbcatsearch ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 24))

(deftrap _catsearch ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 24))

(deftrap _adddrive ((drvrrefnum :signed-integer) (drvnum :signed-integer) (qel (:pointer :drvqel)))
   (:d0 :signed-integer)
   (:register-trap #xA04E :d0 (logior (ash 16 drvnum) (logand #xffff drvrrefnum)) :a0 qel))





#| No 411 description
(deftrap _openrf ((filename (:string 255)) (vrefnum :signed-integer) (refnum (:pointer :signed-integer)))
   (nil :signed-integer)
   (:register-trap #xA00A))
|#
#| Can't match 411 description 
   Entry:nil 
   Exit:nil
(deftrap _rename ((oldname (:string 255)) (vrefnum :signed-integer) (newname (:string 255)))
   (nil :signed-integer)
   (:register-trap #xA00B :no-match oldname :no-match vrefnum :no-match newname))
|#
#| Not in ROM
(deftrap _setfinfo ((filename (:string 255)) (vrefnum :signed-integer) (fndrinfo :finfo))
   (:stack :signed-integer)
   (:stack-trap #x0))
|#
#| Not in ROM
(deftrap _setflock ((filename (:string 255)) (vrefnum :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #x0))
|#
#| Not in ROM
(deftrap _rstflock ((filename (:string 255)) (vrefnum :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #x0))
|#
#| No 411 description
(deftrap _allocate ((refnum :signed-integer) (count (:pointer :signed-long)))
   (nil :signed-integer)
   (:register-trap #xA010))
|#
#| Can't match 411 description 
   Entry:nil 
   Exit:nil
(deftrap _geteof ((refnum :signed-integer) (logeof (:pointer :signed-long)))
   (nil :signed-integer)
   (:register-trap #xA011 :no-match refnum :no-match logeof))
|#
#| Can't match 411 description 
   Entry:nil 
   Exit:nil
(deftrap _seteof ((refnum :signed-integer) (logeof :signed-long))
   (nil :signed-integer)
   (:register-trap #xA012 :no-match refnum :no-match logeof))
|#
#| Can't match 411 description 
   Entry:nil 
   Exit:nil
(deftrap _getfpos ((refnum :signed-integer) (filepos (:pointer :signed-long)))
   (nil :signed-integer)
   (:register-trap #xA018 :no-match refnum :no-match filepos))
|#
#| Can't match 411 description 
   Entry:nil 
   Exit:nil
(deftrap _setfpos ((refnum :signed-integer) (posmode :signed-integer) (posoff :signed-long))
   (nil :signed-integer)
   (:register-trap #xA044 :no-match refnum :no-match posmode :no-match posoff))
|#
#| Not in ROM
(deftrap _getvrefnum ((filerefnum :signed-integer) (vrefnum (:pointer :signed-integer)))
   (:stack :signed-integer)
   (:stack-trap #x0))
|#

(deftrap _pbopenwd ((paramblock (:pointer :wdpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 1))


(deftrap _pbclosewd ((paramblock (:pointer :wdpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 2))

(deftrap _pbhsetvol ((paramblock (:pointer :wdpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA215 :a0 paramblock))

(deftrap _pbhgetvol ((paramblock (:pointer :wdpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA214 :a0 paramblock))

(deftrap _pbcatmove ((paramblock (:pointer :cmovepbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 5))

(deftrap _pbdircreate ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 6))

(deftrap _pbgetwdinfo ((paramblock (:pointer :wdpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 7))

(deftrap _pbgetfcbinfo ((paramblock (:pointer :fcbpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 8))

(deftrap _pbgetcatinfo ((paramblock (:pointer :cinfopbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 9))

(deftrap _pbsetcatinfo ((paramblock (:pointer :cinfopbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 10))

(deftrap _pballoccontig ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA210 :a0 paramblock))

(deftrap _pblockrange ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 16))

(deftrap _pbunlockrange ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 17))

(deftrap _pbsetvinfo ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 11))

(deftrap _pbhgetvinfo ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA207 :a0 paramblock))

(deftrap _pbhopen ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA200 :a0 paramblock))

(deftrap _pbhopenrf ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA20A :a0 paramblock))

(deftrap _pbhopendf ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 26))

(deftrap _pbhcreate ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA208 :a0 paramblock))

(deftrap _pbhdelete ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA209 :a0 paramblock))

(deftrap _pbhrename ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA20B :a0 paramblock))

(deftrap _pbhrstflock ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA242 :a0 paramblock))

(deftrap _pbhsetflock ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA241 :a0 paramblock))

(deftrap _pbhgetfinfo ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA20C :a0 paramblock))

(deftrap _pbhsetfinfo ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA20D :a0 paramblock))

(deftrap _pbmakefsspec ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 27))

(deftrap _openwd ((paramblock (:pointer :wdpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 1))


(deftrap _closewd ((paramblock (:pointer :wdpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 2))

(deftrap _hsetvol ((paramblock (:pointer :wdpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA215 :a0 paramblock))

(deftrap _hgetvol ((paramblock (:pointer :wdpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA214 :a0 paramblock))

(deftrap _catmove ((paramblock (:pointer :cmovepbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 5))

(deftrap _dircreate ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 6))

(deftrap _getwdinfo ((paramblock (:pointer :wdpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 7))

(deftrap _getfcbinfo ((paramblock (:pointer :fcbpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 8))

(deftrap _getcatinfo ((paramblock (:pointer :cinfopbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 9))

(deftrap _setcatinfo ((paramblock (:pointer :cinfopbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 10))

(deftrap _alloccontig ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA210 :a0 paramblock))

(deftrap _lockrange ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 16))

(deftrap _unlockrange ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 17))

(deftrap _setvinfo ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 11))

(deftrap _hgetvinfo ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA207 :a0 paramblock))

(deftrap _hopen ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA200 :a0 paramblock))

(deftrap _hopenrf ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA20A :a0 paramblock))

(deftrap _hopendf ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 26))

(deftrap _hcreate ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA208 :a0 paramblock))

(deftrap _hdelete ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA209 :a0 paramblock))

(deftrap _hrename ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA20B :a0 paramblock))

(deftrap _hrstflock ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA242 :a0 paramblock))

(deftrap _hsetflock ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA241 :a0 paramblock))

(deftrap _hgetfinfo ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA20C :a0 paramblock))

(deftrap _hsetfinfo ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA20D :a0 paramblock))

(deftrap _makefsspec ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 27))

(deftrap _finitqueue nil
   nil
   (:stack-trap #xA016))

(deftrap _getfsqhdr nil
   (:no-trap (:pointer :qhdr))
   (:no-trap (%get-ptr (%int-to-ptr #x0360))))

(deftrap _getdrvqhdr nil
   (:no-trap (:pointer :qhdr))
   (:no-trap (%get-ptr (%int-to-ptr #x0308))))

(deftrap _getvcbqhdr nil
   (:no-trap (:pointer :qhdr))
   (:no-trap (%get-ptr (%int-to-ptr #x0356))))


#| No 411 description
(deftrap _hgetvol ((volname (:pointer (:string 255))) (vrefnum (:pointer :signed-integer)) (dirid (:pointer :signed-long)))
   (nil :signed-integer)
   (:register-trap #xA214))
|#
#| No 411 description
(deftrap _hsetvol ((volname (:pointer (:string 255))) (vrefnum :signed-integer) (dirid :signed-long))
   (nil :signed-integer)
   (:register-trap #xA215))
|#
#| No 411 description
(deftrap _hopen ((vrefnum :signed-integer) (dirid :signed-long) (filename (:string 255)) (permission :signed-byte) (refnum (:pointer :signed-integer)))
   (nil :signed-integer)
   (:register-trap #xA200))
|#
#| Not in ROM
(deftrap _hopendf ((vrefnum :signed-integer) (dirid :signed-long) (filename (:string 255)) (permission :signed-byte) (refnum (:pointer :signed-integer)))
   (:stack :signed-integer)
   (:stack-trap #x0))
|#
#| No 411 description
(deftrap _hopenrf ((vrefnum :signed-integer) (dirid :signed-long) (filename (:string 255)) (permission :signed-byte) (refnum (:pointer :signed-integer)))
   (nil :signed-integer)
   (:register-trap #xA20A))
|#
#| Can't match 411 description 
   Entry:nil 
   Exit:nil
(deftrap _alloccontig ((refnum :signed-integer) (count (:pointer :signed-long)))
   (nil :signed-integer)
   (:register-trap #xA210 :no-match refnum :no-match count))
|#
#| No 411 description
(deftrap _hcreate ((vrefnum :signed-integer) (dirid :signed-long) (filename (:string 255)) (creator :ostype) (filetype :ostype))
   (nil :signed-integer)
   (:register-trap #xA208))
|#
#| Not in ROM
(deftrap _dircreate ((vrefnum :signed-integer) (parentdirid :signed-long) (directoryname (:string 255)) (createddirid (:pointer :signed-long)))
   (:stack :signed-integer)
   (:stack-trap #x0))
|#
#| No 411 description
(deftrap _hdelete ((vrefnum :signed-integer) (dirid :signed-long) (filename (:string 255)))
   (nil :signed-integer)
   (:register-trap #xA209))
|#
#| Not in ROM
(deftrap _hgetfinfo ((vrefnum :signed-integer) (dirid :signed-long) (filename (:string 255)) (fndrinfo (:pointer :finfo)))
   (:stack :signed-integer)
   (:stack-trap #x0))
|#
#| Not in ROM
(deftrap _hsetfinfo ((vrefnum :signed-integer) (dirid :signed-long) (filename (:string 255)) (fndrinfo :finfo))
   (:stack :signed-integer)
   (:stack-trap #x0))
|#
#| No 411 description
(deftrap _hsetflock ((vrefnum :signed-integer) (dirid :signed-long) (filename (:string 255)))
   (nil :signed-integer)
   (:register-trap #xA241))
|#
#| No 411 description
(deftrap _hrstflock ((vrefnum :signed-integer) (dirid :signed-long) (filename (:string 255)))
   (nil :signed-integer)
   (:register-trap #xA242))
|#
#| No 411 description
(deftrap _hrename ((vrefnum :signed-integer) (dirid :signed-long) (oldname (:string 255)) (newname (:string 255)))
   (nil :signed-integer)
   (:register-trap #xA20B))
|#
#| Not in ROM
(deftrap _catmove ((vrefnum :signed-integer) (dirid :signed-long) (oldname (:string 255)) (newdirid :signed-long) (newname (:string 255)))
   (:stack :signed-integer)
   (:stack-trap #x0))
|#
#| Not in ROM
(deftrap _openwd ((vrefnum :signed-integer) (dirid :signed-long) (procid :signed-long) (wdrefnum (:pointer :signed-integer)))
   (:stack :signed-integer)
   (:stack-trap #x0))
|#
#| Not in ROM
(deftrap _closewd ((wdrefnum :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #x0))
|#
#| Not in ROM
(deftrap _getwdinfo ((wdrefnum :signed-integer) (vrefnum (:pointer :signed-integer)) (dirid (:pointer :signed-long)) (procid (:pointer :signed-long)))
   (:stack :signed-integer)
   (:stack-trap #x0))
|#

(deftrap _pbhgetvolparms ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 48))

(deftrap _pbhgetlogininfo ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 49))

(deftrap _pbhgetdiraccess ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 50))

(deftrap _pbhsetdiraccess ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 51))

(deftrap _pbhmapid ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 52))

(deftrap _pbhmapname ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 53))

(deftrap _pbhcopyfile ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 54))

(deftrap _pbhmoverename ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 55))

(deftrap _pbhopendeny ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 56))

(deftrap _pbhopenrfdeny ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 57))

(deftrap _pbexchangefiles ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 23))

(deftrap _pbcreatefileidref ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 20))

(deftrap _pbresolvefileidref ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 22))

(deftrap _pbdeletefileidref ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 21))

(deftrap _pbgetforeignprivs ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 96))

(deftrap _pbsetforeignprivs ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 97))

(deftrap _hgetvolparms ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 48))

(deftrap _hgetlogininfo ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 49))

(deftrap _hgetdiraccess ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 50))

(deftrap _hsetdiraccess ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 51))

(deftrap _hmapid ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 52))

(deftrap _hmapname ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 53))

(deftrap _hcopyfile ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 54))

(deftrap _hmoverename ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 55))

(deftrap _hopendeny ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 56))

(deftrap _hopenrfdeny ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 57))

(deftrap _exchangefiles ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 23))

(deftrap _createfileidref ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 20))

(deftrap _resolvefileidref ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 22))

(deftrap _deletefileidref ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 21))

(deftrap _getforeignprivs ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 96))

(deftrap _setforeignprivs ((paramblock (:pointer :hparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 97))

;   Desktop Manager  

(deftrap _pbdtgetpath ((paramblock (:pointer :dtpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 32))

(deftrap _pbdtclosedown ((paramblock (:pointer :dtpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 33))

(deftrap _pbdtaddicon ((paramblock (:pointer :dtpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 34))

(deftrap _pbdtgeticon ((paramblock (:pointer :dtpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 35))

(deftrap _pbdtgeticoninfo ((paramblock (:pointer :dtpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 36))

(deftrap _pbdtaddappl ((paramblock (:pointer :dtpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 37))

(deftrap _pbdtremoveappl ((paramblock (:pointer :dtpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 38))

(deftrap _pbdtgetappl ((paramblock (:pointer :dtpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 39))

(deftrap _pbdtsetcomment ((paramblock (:pointer :dtpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 40))

(deftrap _pbdtremovecomment ((paramblock (:pointer :dtpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 41))

(deftrap _pbdtgetcomment ((paramblock (:pointer :dtpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 42))

(deftrap _pbdtflush ((paramblock (:pointer :dtpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 43))

(deftrap _pbdtreset ((paramblock (:pointer :dtpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 44))

(deftrap _pbdtgetinfo ((paramblock (:pointer :dtpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 45))

(deftrap _pbdtopeninform ((paramblock (:pointer :dtpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA060 :a0 paramblock :d0 46))

(deftrap _pbdtdelete ((paramblock (:pointer :dtpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA060 :a0 paramblock :d0 47))

(deftrap _pbgetvolmountinfosize ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 63))

(deftrap _pbgetvolmountinfo ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 64))

(deftrap _pbvolumemount ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 65))

(deftrap _dtgetpath ((paramblock (:pointer :dtpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 32))

(deftrap _dtclosedown ((paramblock (:pointer :dtpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 33))

(deftrap _dtaddicon ((paramblock (:pointer :dtpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 34))

(deftrap _dtgeticon ((paramblock (:pointer :dtpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 35))

(deftrap _dtgeticoninfo ((paramblock (:pointer :dtpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 36))

(deftrap _dtaddappl ((paramblock (:pointer :dtpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 37))

(deftrap _dtremoveappl ((paramblock (:pointer :dtpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 38))

(deftrap _dtgetappl ((paramblock (:pointer :dtpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 39))

(deftrap _dtsetcomment ((paramblock (:pointer :dtpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 40))

(deftrap _dtremovecomment ((paramblock (:pointer :dtpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 41))

(deftrap _dtgetcomment ((paramblock (:pointer :dtpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 42))

(deftrap _dtflush ((paramblock (:pointer :dtpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 43))

(deftrap _dtreset ((paramblock (:pointer :dtpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 44))

(deftrap _dtgetinfo ((paramblock (:pointer :dtpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 45))

(deftrap _dtopeninform ((paramblock (:pointer :dtpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA060 :a0 paramblock :d0 46))

(deftrap _dtdelete ((paramblock (:pointer :dtpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA060 :a0 paramblock :d0 47))

(deftrap _getvolmountinfosize ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 63))

(deftrap _getvolmountinfo ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 64))

(deftrap _volumemount ((paramblock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA260 :a0 paramblock :d0 65))


;   FSSpec Glue  

(deftrap _fsmakefsspec ((vrefnum :signed-integer) (dirid :signed-long) (filename (:string 255)) (spec (:pointer :fsspec)))
   (:stack :signed-integer)
   (:stack-trap #xAA52 :d0 1 vrefnum dirid filename spec))

(deftrap _fspopendf ((spec :fsspec) (permission :signed-byte) (refnum (:pointer :signed-integer)))
   (:stack :signed-integer)
   (:stack-trap #xAA52 :d0 2 spec permission refnum))

(deftrap _fspopenrf ((spec :fsspec) (permission :signed-byte) (refnum (:pointer :signed-integer)))
   (:stack :signed-integer)
   (:stack-trap #xAA52 :d0 3 spec permission refnum))

(deftrap _fspcreate ((spec :fsspec) (creator :ostype) (filetype :ostype) (scripttag :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xAA52 :d0 4 spec creator filetype scripttag))

(deftrap _fspdircreate ((spec :fsspec) (scripttag :signed-integer) (createddirid (:pointer :signed-long)))
   (:stack :signed-integer)
   (:stack-trap #xAA52 :d0 5 spec scripttag createddirid))

(deftrap _fspdelete ((spec :fsspec))
   (:stack :signed-integer)
   (:stack-trap #xAA52 :d0 6 spec))

(deftrap _fspgetfinfo ((spec :fsspec) (fndrinfo (:pointer :finfo)))
   (:stack :signed-integer)
   (:stack-trap #xAA52 :d0 7 spec fndrinfo))

(deftrap _fspsetfinfo ((spec :fsspec) (fndrinfo :finfo))
   (:stack :signed-integer)
   (:stack-trap #xAA52 :d0 8 spec fndrinfo))

(deftrap _fspsetflock ((spec :fsspec))
   (:stack :signed-integer)
   (:stack-trap #xAA52 :d0 9 spec))

(deftrap _fsprstflock ((spec :fsspec))
   (:stack :signed-integer)
   (:stack-trap #xAA52 :d0 10 spec))

(deftrap _fsprename ((spec :fsspec) (newname (:string 255)))
   (:stack :signed-integer)
   (:stack-trap #xAA52 :d0 11 spec newname))

(deftrap _fspcatmove ((source :fsspec) (dest :fsspec))
   (:stack :signed-integer)
   (:stack-trap #xAA52 :d0 12 source dest))

(deftrap _fspexchangefiles ((source :fsspec) (dest :fsspec))
   (:stack :signed-integer)
   (:stack-trap #xAA52 :d0 15 source dest))

; $ENDC                         ;  UsingFiles 

; $IFC NOT UsingIncludes

; $ENDC


(export '($applesharemediatype $dirinfo $hfileinfo $ktwowayencryptpassword
          $kencryptpassword $kpassword $knouserauthentication $finalstage
          $betastage $alphastage $developstage $fsunixpriv $ksmall8biticonsize
          $ksmall4biticonsize $ksmalliconsize $klarge8biticonsize
          $klarge4biticonsize $klargeiconsize $ksmall8biticon $ksmall4biticon
          $ksmallicon $klarge8biticon $klarge4biticon $klargeicon
          $bhasblankaccessprivileges $bhasbtreemgr $bhasfileids $bhascatsearch
          $bhasusergrouplist $bhaspersonalaccessprivileges $bhasfolderlock
          $bhasshortname $bhasdesktopmgr $bhasmoverename $bhascopyfile
          $bhasopendeny $bhasextfsvol $bnosysdir $baccesscntl $bnobootblks
          $bnodeskitems $bnoswitchto $btrshoffline $bnolclsync $bnovnedit
          $bnominifndr $blocalwlist $blimitfcbs $fssbdrparid $fssbdrfndrinfo
          $fssbdrbkdat $fssbdrmddat $fssbdrcrdat $fssbdrnmfls $fssbdrusrwds
          $fssbnegate $fssbflparid $fssbflxfndrinfo $fssbflbkdat $fssbflmddat
          $fssbflcrdat $fssbflrpylen $fssbflrlglen $fssbflpylen $fssbfllglen
          $fssbflfndrinfo $fssbflattrib $fssbfullname $fssbpartialname
          $fsrtdirid $fsrtparid $iodirmask $iodirflg $rdverify $fsfrommark
          $fsfromleof $fsfromstart $fsrdwrshperm $fdisk $fsrdwrperm $fdesktop
          $fswrperm $ftrash $finvisible $fsrdperm $fhasbundle $fscurperm
          $fondesk $fsatmark))
(provide-interface 'FILES)