
(in-package :TRAPS)
; 
; Created: Wednesday, August 14, 1991 at 12:36 PM
;  Movies.p
;  Pascal Interface to the Macintosh Libraries
; 
;   Copyright Apple Computer, Inc. 1991
;   All rights reserved
; 
; 

; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED UsingMovies
; $SETC UsingMovies := 1

; $I+
; $SETC MoviesIncludes := UsingIncludes
; $SETC UsingIncludes := 1
; $IFC UNDEFINED UsingQuickDraw

(require-interface 'QUICKDRAW)  ; $I $$Shell(PInterfaces)QuickDraw.p
; $ENDC
; $IFC UNDEFINED UsingAliases

(require-interface 'ALIASES)    ; $I $$Shell(PInterfaces)Aliases.p
; $ENDC
; $IFC UNDEFINED UsingEvents

(require-interface 'EVENTS)     ; $I $$Shell(PInterfaces)Events.p
; $ENDC
; $IFC UNDEFINED UsingComponents

(require-interface 'COMPONENTS) ; $I $$Shell(PInterfaces)Components.p
; $ENDC
; $IFC UNDEFINED UsingImageCompression

(require-interface 'IMAGECOMPRESSION); $I $$Shell(PInterfaces)ImageCompression.p
; $ENDC
; $SETC UsingIncludes := MoviesIncludes

(defconstant $gestaltQuickTime :|qtim|)

(defconstant $MovieFileType :|MooV|)

(defconstant $VideoMediaType :|vide|)
(defconstant $SoundMediaType :|soun|)

(defconstant $DoTheRightThing 0)

(defconstant $kFullVolume #X100);  8.8 format 
(defconstant $kNoVolume 0)

(def-mactype :MOVIE (find-mactype :POINTER))
(defrecord MovieRecord 
   (data (:ARRAY :SIGNED-LONG 1))
   )

(def-mactype :TRACK (find-mactype :POINTER))
(defrecord TrackRecord 
   (data (:ARRAY :SIGNED-LONG 1))
   )

(def-mactype :MEDIA (find-mactype :POINTER))
(defrecord MediaRecord 
   (data (:ARRAY :SIGNED-LONG 1))
   )

(def-mactype :USERDATA (find-mactype :POINTER))
(defrecord UserDataRecord 
   (data (:ARRAY :SIGNED-LONG 1))
   )

(def-mactype :TRACKEDITSTATE (find-mactype :POINTER))
(defrecord TrackEditStateRecord 
   (data (:ARRAY :SIGNED-LONG 1))
   )

(def-mactype :MOVIEEDITSTATE (find-mactype :POINTER))
(defrecord MovieEditStateRecord 
   (data (:ARRAY :SIGNED-LONG 1))
   )

(def-mactype :TIMEVALUE (find-mactype :SIGNED-LONG))
(def-mactype :TIMESCALE (find-mactype :SIGNED-LONG))

(def-mactype :TIMEBASE (find-mactype :POINTER))
(defrecord TimeBaseRecord 
   (data (:ARRAY :SIGNED-LONG 1))
   )

(def-mactype :QTCALLBACK (find-mactype :POINTER))
(defrecord CallBackRecord 
   (data (:ARRAY :SIGNED-LONG 1))
   )

(defrecord Int64 
   (hi :SIGNED-LONG)
   (lo :SIGNED-LONG)
   )

(defrecord TimeRecord 
   (value :INT64)
   (scale :SIGNED-LONG)
   (base (:POINTER :TIMEBASERECORD))
   )

(def-mactype :SAMPLEDESCRIPTIONPTR (find-mactype :POINTER))
(def-mactype :SAMPLEDESCRIPTIONHANDLE (find-mactype :HANDLE))
(defrecord (SampleDescription :handle) 
   (descSize :SIGNED-LONG)
   (dataFormat :SIGNED-LONG)
   )

(def-mactype :SOUNDDESCRIPTIONPTR (find-mactype :POINTER))
(def-mactype :SOUNDDESCRIPTIONHANDLE (find-mactype :HANDLE))
(defrecord (SoundDescription :handle) 
   (descSize :SIGNED-LONG)
   (dataFormat :SIGNED-LONG)
   (resvd1 :SIGNED-LONG)
   (resvd2 :SIGNED-INTEGER)
   (dataRefIndex :SIGNED-INTEGER)
   (version :SIGNED-INTEGER)
   (revlevel :SIGNED-INTEGER)
   (vendor :SIGNED-LONG)
   (numChannels :SIGNED-INTEGER)
   (sampleSize :SIGNED-INTEGER)
   (compressionID :SIGNED-INTEGER)
   (packetSize :SIGNED-INTEGER)
   (sampleRate :SIGNED-LONG)
   )

;  progress messages 
(defconstant $movieProgressOpen 0)
(defconstant $movieProgressUpdatePercent 1)
(defconstant $movieProgressClose 2)

;  progress operations 
(defconstant $progressOpFlatten 1)
(defconstant $progressOpInsertTrackSegment 2)
(defconstant $progressOpInsertMovieSegment 3)
(defconstant $progressOpPaste 4)
(defconstant $progressOpAddMovieSelection 5)
(defconstant $progressOpCopy 6)
(defconstant $progressOpCut 7)
(defconstant $progressOpLoadMovieIntoRam 8)
(defconstant $progressOpLoadTrackIntoRam 9)
(defconstant $progressOpLoadMediaIntoRam 10)

;  media quality settings 
(defconstant $mediaQualityDraft #X0)
(defconstant $mediaQualityNormal #X40)
(defconstant $mediaQualityBetter #X80)
(defconstant $mediaQualityBest #XC0)

(def-mactype :MOVIEPROGRESSPROCPTR (find-mactype :POINTER))

(def-mactype :MOVIERGNCOVERPROC (find-mactype :POINTER))

(def-mactype :MEDIAINFORMATIONHANDLE (find-mactype :HANDLE))
(def-mactype :MEDIAHANDLER (find-mactype :POINTER))
(def-mactype :MEDIAHANDLERCOMPONENT (find-mactype :POINTER))
(def-mactype :DATAHANDLER (find-mactype :POINTER))
(def-mactype :DATAHANDLERCOMPONENT (find-mactype :POINTER))
(def-mactype :HANDLERERROR (find-mactype :SIGNED-LONG))
(def-mactype :MOVIECONTROLLER (find-mactype :POINTER))

(def-mactype :ERRORPROCPTR (find-mactype :POINTER))
(def-mactype :MOVIEPREVIEWCALLOUTPROC (find-mactype :POINTER))

(defconstant $newMovieActive #X1)
(defconstant $newMovieDontResolveDataRefs #X2)
(defconstant $newMovieDontAskUnresolvedDataRefs #X4)

(defconstant $trackUsageInMovie #X2)
(defconstant $trackUsageInPreview #X4)
(defconstant $trackUsageInPoster #X8)

(defconstant $mediaSampleNotSync 1)

(defconstant $nextTimeMediaSample #X1)
(defconstant $nextTimeMediaEdit #X2)
(defconstant $nextTimeTrackEdit #X4)
(defconstant $nextTimeSyncSample #X8)
(defconstant $nextTimeEdgeOK #X2000)
(defconstant $nextTimeIgnoreActiveSegment #X4000)

(defconstant $createMovieFileDeleteCurFile #X80000000)
(defconstant $createMovieFileDontCreateMovie #X40000000)
(defconstant $createMovieFileDontOpenFile #X20000000)

(defconstant $flattenAddMovieToDataFork #X1)
(defconstant $flattenActiveTracksOnly #X4)
(defconstant $flattenDontInterleaveFlatten #X8)

(defconstant $movieScrapDontZeroScrap #X1)
(defconstant $movieScrapOnlyPutMovie #X2)

(defconstant $hintsScrubMode #X1)

;   Initialization Routines  

(deftrap _ENTERMOVIES NIL
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 1))

(deftrap _EXITMOVIES NIL
   NIL
   (:STACK-TRAP #xAAAA :D0 2))

;   error Routines  

(deftrap _GETMOVIESERROR NIL
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 3))

(deftrap _CLEARMOVIESSTICKYERROR NIL
   NIL
   (:STACK-TRAP #xAAAA :D0 222))

(deftrap _GETMOVIESSTICKYERROR NIL
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 4))


(deftrap _SETMOVIESERRORPROC ((ERRPROC :POINTER) (REFCON :SIGNED-LONG))
   NIL
   (:STACK-TRAP #xAAAA :D0 239 ERRPROC REFCON))


(deftrap _GETTRACKSTATUS ((T (:POINTER :TRACKRECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 370 T))

(deftrap _GETMOVIESTATUS ((M (:POINTER :MOVIERECORD)) (FIRSTPROBLEMTRACK (:POINTER (:POINTER :TRACKRECORD))))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 371 M FIRSTPROBLEMTRACK))

;   Playback Routines  

(deftrap _MOVIESTASK ((M (:POINTER :MOVIERECORD)) (MAXMILLISECTOUSE :SIGNED-LONG))
   NIL
   (:STACK-TRAP #xAAAA :D0 5 M MAXMILLISECTOUSE))


(deftrap _STARTMOVIE ((M (:POINTER :MOVIERECORD)))
   NIL
   (:STACK-TRAP #xAAAA :D0 11 M))

(deftrap _STOPMOVIE ((M (:POINTER :MOVIERECORD)))
   NIL
   (:STACK-TRAP #xAAAA :D0 12 M))

(deftrap _GOTOBEGINNINGOFMOVIE ((M (:POINTER :MOVIERECORD)))
   NIL
   (:STACK-TRAP #xAAAA :D0 13 M))

(deftrap _GOTOENDOFMOVIE ((M (:POINTER :MOVIERECORD)))
   NIL
   (:STACK-TRAP #xAAAA :D0 14 M))

(deftrap _ISMOVIEDONE ((M (:POINTER :MOVIERECORD)))
   (:STACK :BOOLEAN)
   (:STACK-TRAP #xAAAA :D0 221 M))


(deftrap _GETMOVIEPREVIEWMODE ((M (:POINTER :MOVIERECORD)))
   (:STACK :BOOLEAN)
   (:STACK-TRAP #xAAAA :D0 15 M))

(deftrap _SETMOVIEPREVIEWMODE ((M (:POINTER :MOVIERECORD)) (USEPREVIEW :BOOLEAN))
   NIL
   (:STACK-TRAP #xAAAA :D0 16 M USEPREVIEW))

(deftrap _SHOWMOVIEPOSTER ((M (:POINTER :MOVIERECORD)))
   NIL
   (:STACK-TRAP #xAAAA :D0 17 M))


(deftrap _GETMOVIEGWORLD ((M (:POINTER :MOVIERECORD)) (PORT (:POINTER (:POINTER :CGRAFPORT))) (GDH (:POINTER (:HANDLE :GDEVICE))))
   NIL
   (:STACK-TRAP #xAAAA :D0 21 M PORT GDH))

(deftrap _SETMOVIEGWORLD ((M (:POINTER :MOVIERECORD)) (PORT (:POINTER :CGRAFPORT)) (GDH (:HANDLE :GDEVICE)))
   NIL
   (:STACK-TRAP #xAAAA :D0 22 M PORT GDH))


(deftrap _PREROLLMOVIE ((M (:POINTER :MOVIERECORD)) (TIME :SIGNED-LONG) (RATE :SIGNED-LONG))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 6 M TIME RATE))

(deftrap _LOADMOVIEINTORAM ((M (:POINTER :MOVIERECORD)) (TIME :SIGNED-LONG) (DURATION :SIGNED-LONG) (FLAGS :SIGNED-LONG))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 7 M TIME DURATION FLAGS))

(deftrap _LOADTRACKINTORAM ((T (:POINTER :TRACKRECORD)) (TIME :SIGNED-LONG) (DURATION :SIGNED-LONG) (FLAGS :SIGNED-LONG))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 366 T TIME DURATION FLAGS))

(deftrap _LOADMEDIAINTORAM ((M (:POINTER :MEDIARECORD)) (TIME :SIGNED-LONG) (DURATION :SIGNED-LONG) (FLAGS :SIGNED-LONG))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 8 M TIME DURATION FLAGS))


(deftrap _SETMOVIEACTIVE ((M (:POINTER :MOVIERECORD)) (ACTIVE :BOOLEAN))
   NIL
   (:STACK-TRAP #xAAAA :D0 9 M ACTIVE))

(deftrap _GETMOVIEACTIVE ((M (:POINTER :MOVIERECORD)))
   (:STACK :BOOLEAN)
   (:STACK-TRAP #xAAAA :D0 10 M))


(deftrap _PLAYMOVIEPREVIEW ((M (:POINTER :MOVIERECORD)) (CALLOUTPROC :POINTER) (REFCON :SIGNED-LONG))
   NIL
   (:STACK-TRAP #xAAAA :D0 242 M CALLOUTPROC REFCON))

;   Movie PICT Routines  

(deftrap _GETMOVIEPICT ((M (:POINTER :MOVIERECORD)) (TIME :SIGNED-LONG))
   (:STACK (:HANDLE :PICTURE))
   (:STACK-TRAP #xAAAA :D0 29 M TIME))

(deftrap _GETTRACKPICT ((T (:POINTER :TRACKRECORD)) (TIME :SIGNED-LONG))
   (:STACK (:HANDLE :PICTURE))
   (:STACK-TRAP #xAAAA :D0 30 T TIME))


(deftrap _GETMOVIEPOSTERPICT ((M (:POINTER :MOVIERECORD)))
   (:STACK (:HANDLE :PICTURE))
   (:STACK-TRAP #xAAAA :D0 247 M))

;   movie TimeBase Routines  

(deftrap _GETMOVIETIMEBASE ((M (:POINTER :MOVIERECORD)))
   (:STACK (:POINTER :TIMEBASERECORD))
   (:STACK-TRAP #xAAAA :D0 18 M))


(deftrap _SETMOVIEMASTERTIMEBASE ((M (:POINTER :MOVIERECORD)) (TB (:POINTER :TIMEBASERECORD)) (SLAVEZERO :TIMERECORD))
   NIL
   (:STACK-TRAP #xAAAA :D0 359 M TB SLAVEZERO))

(deftrap _SETMOVIEMASTERCLOCK ((M (:POINTER :MOVIERECORD)) (CLOCKMEISTER (:POINTER :COMPONENTRECORD)) (SLAVEZERO :TIMERECORD))
   NIL
   (:STACK-TRAP #xAAAA :D0 360 M CLOCKMEISTER SLAVEZERO))

;   spatial movie Routines  

(deftrap _GETMOVIEBOX ((M (:POINTER :MOVIERECORD)) (BOXRECT (:POINTER :RECT)))
   NIL
   (:STACK-TRAP #xAAAA :D0 249 M BOXRECT))

(deftrap _SETMOVIEBOX ((M (:POINTER :MOVIERECORD)) (BOXRECT :RECT))
   NIL
   (:STACK-TRAP #xAAAA :D0 250 M BOXRECT))

;   movie display clip  

(deftrap _GETMOVIEDISPLAYCLIPRGN ((M (:POINTER :MOVIERECORD)))
   (:STACK (:HANDLE :REGION))
   (:STACK-TRAP #xAAAA :D0 252 M))

(deftrap _SETMOVIEDISPLAYCLIPRGN ((M (:POINTER :MOVIERECORD)) (THECLIP (:HANDLE :REGION)))
   NIL
   (:STACK-TRAP #xAAAA :D0 253 M THECLIP))

;   movie clip  

(deftrap _GETMOVIECLIPRGN ((M (:POINTER :MOVIERECORD)))
   (:STACK (:HANDLE :REGION))
   (:STACK-TRAP #xAAAA :D0 256 M))

(deftrap _SETMOVIECLIPRGN ((M (:POINTER :MOVIERECORD)) (THECLIP (:HANDLE :REGION)))
   NIL
   (:STACK-TRAP #xAAAA :D0 257 M THECLIP))

;   track clip  

(deftrap _GETTRACKCLIPRGN ((T (:POINTER :TRACKRECORD)))
   (:STACK (:HANDLE :REGION))
   (:STACK-TRAP #xAAAA :D0 258 T))

(deftrap _SETTRACKCLIPRGN ((T (:POINTER :TRACKRECORD)) (THECLIP (:HANDLE :REGION)))
   NIL
   (:STACK-TRAP #xAAAA :D0 259 T THECLIP))

;   bounds in display space  

(deftrap _GETMOVIEDISPLAYBOUNDSRGN ((M (:POINTER :MOVIERECORD)))
   (:STACK (:HANDLE :REGION))
   (:STACK-TRAP #xAAAA :D0 251 M))

(deftrap _GETTRACKDISPLAYBOUNDSRGN ((T (:POINTER :TRACKRECORD)))
   (:STACK (:HANDLE :REGION))
   (:STACK-TRAP #xAAAA :D0 274 T))

;   bounds in movie space  

(deftrap _GETMOVIEBOUNDSRGN ((M (:POINTER :MOVIERECORD)))
   (:STACK (:HANDLE :REGION))
   (:STACK-TRAP #xAAAA :D0 254 M))

(deftrap _GETTRACKMOVIEBOUNDSRGN ((T (:POINTER :TRACKRECORD)))
   (:STACK (:HANDLE :REGION))
   (:STACK-TRAP #xAAAA :D0 255 T))

;   bounds in track space  

(deftrap _GETTRACKBOUNDSRGN ((T (:POINTER :TRACKRECORD)))
   (:STACK (:HANDLE :REGION))
   (:STACK-TRAP #xAAAA :D0 273 T))

;   movie poster box  

(deftrap _GETPOSTERBOX ((M (:POINTER :MOVIERECORD)) (BOXRECT (:POINTER :RECT)))
   NIL
   (:STACK-TRAP #xAAAA :D0 367 M BOXRECT))

(deftrap _SETPOSTERBOX ((M (:POINTER :MOVIERECORD)) (BOXRECT :RECT))
   NIL
   (:STACK-TRAP #xAAAA :D0 368 M BOXRECT))

;   movie/track bounds over a range of time  

(deftrap _GETMOVIESEGMENTDISPLAYBOUNDSRGN ((M (:POINTER :MOVIERECORD)) (TIME :SIGNED-LONG) (DURATION :SIGNED-LONG))
   (:STACK (:HANDLE :REGION))
   (:STACK-TRAP #xAAAA :D0 364 M TIME DURATION))

(deftrap _GETTRACKSEGMENTDISPLAYBOUNDSRGN ((T (:POINTER :TRACKRECORD)) (TIME :SIGNED-LONG) (DURATION :SIGNED-LONG))
   (:STACK (:HANDLE :REGION))
   (:STACK-TRAP #xAAAA :D0 363 T TIME DURATION))


(deftrap _SETMOVIECOVERPROCS ((M (:POINTER :MOVIERECORD)) (UNCOVERPROC :POINTER) (COVERPROC :POINTER) (REFCON :SIGNED-LONG))
   NIL
   (:STACK-TRAP #xAAAA :D0 377 M UNCOVERPROC COVERPROC REFCON))

;   mattes - always in track space  

(deftrap _GETTRACKMATTE ((T (:POINTER :TRACKRECORD)))
   (:STACK (:HANDLE :PIXMAP))
   (:STACK-TRAP #xAAAA :D0 277 T))

(deftrap _SETTRACKMATTE ((T (:POINTER :TRACKRECORD)) (THEMATTE (:HANDLE :PIXMAP)))
   NIL
   (:STACK-TRAP #xAAAA :D0 278 T THEMATTE))

(deftrap _DISPOSEMATTE ((THEMATTE (:HANDLE :PIXMAP)))
   NIL
   (:STACK-TRAP #xAAAA :D0 330 THEMATTE))

;   movie creation Routines  

(deftrap _NEWMOVIEFROMHANDLE ((M (:POINTER (:POINTER :MOVIERECORD))) (H :HANDLE) (NEWMOVIEFLAGS :SIGNED-INTEGER) (DATAREFWASCHANGED (:POINTER :BOOLEAN)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 241 M H NEWMOVIEFLAGS DATAREFWASCHANGED))

(deftrap _PUTMOVIEINTOHANDLE ((M (:POINTER :MOVIERECORD)) (H :HANDLE))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 34 M H))


(deftrap _NEWMOVIE ((NEWMOVIEFLAGS :SIGNED-LONG))
   (:STACK (:POINTER :MOVIERECORD))
   (:STACK-TRAP #xAAAA :D0 391 NEWMOVIEFLAGS))

(deftrap _DISPOSEMOVIE ((M (:POINTER :MOVIERECORD)))
   NIL
   (:STACK-TRAP #xAAAA :D0 35 M))

;   Movie Routines  

(deftrap _GETMOVIECREATIONTIME ((M (:POINTER :MOVIERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 38 M))

(deftrap _GETMOVIEMODIFICATIONTIME ((M (:POINTER :MOVIERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 39 M))


(deftrap _GETMOVIETIMESCALE ((M (:POINTER :MOVIERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 41 M))

(deftrap _SETMOVIETIMESCALE ((M (:POINTER :MOVIERECORD)) (TIMESCALE :SIGNED-LONG))
   NIL
   (:STACK-TRAP #xAAAA :D0 42 M TIMESCALE))


(deftrap _GETMOVIEDURATION ((M (:POINTER :MOVIERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 43 M))


(deftrap _GETMOVIERATE ((M (:POINTER :MOVIERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 44 M))

(deftrap _SETMOVIERATE ((M (:POINTER :MOVIERECORD)) (RATE :SIGNED-LONG))
   NIL
   (:STACK-TRAP #xAAAA :D0 45 M RATE))


(deftrap _GETMOVIEPREFERREDRATE ((M (:POINTER :MOVIERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 243 M))

(deftrap _SETMOVIEPREFERREDRATE ((M (:POINTER :MOVIERECORD)) (RATE :SIGNED-LONG))
   NIL
   (:STACK-TRAP #xAAAA :D0 244 M RATE))


(deftrap _GETMOVIEPREFERREDVOLUME ((M (:POINTER :MOVIERECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 245 M))

(deftrap _SETMOVIEPREFERREDVOLUME ((M (:POINTER :MOVIERECORD)) (VOLUME :SIGNED-INTEGER))
   NIL
   (:STACK-TRAP #xAAAA :D0 246 M VOLUME))


(deftrap _GETMOVIEVOLUME ((M (:POINTER :MOVIERECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 46 M))

(deftrap _SETMOVIEVOLUME ((M (:POINTER :MOVIERECORD)) (VOLUME :SIGNED-INTEGER))
   NIL
   (:STACK-TRAP #xAAAA :D0 47 M VOLUME))


(deftrap _GETMOVIEMATRIX ((M (:POINTER :MOVIERECORD)) (MATRIX (:POINTER :MATRIXRECORD)))
   NIL
   (:STACK-TRAP #xAAAA :D0 49 M MATRIX))

(deftrap _SETMOVIEMATRIX ((M (:POINTER :MOVIERECORD)) (MATRIX :MATRIXRECORD))
   NIL
   (:STACK-TRAP #xAAAA :D0 50 M MATRIX))


(deftrap _GETMOVIEPREVIEWTIME ((M (:POINTER :MOVIERECORD)) (PREVIEWTIME (:POINTER :SIGNED-LONG)) (PREVIEWDURATION (:POINTER :SIGNED-LONG)))
   NIL
   (:STACK-TRAP #xAAAA :D0 51 M PREVIEWTIME PREVIEWDURATION))

(deftrap _SETMOVIEPREVIEWTIME ((M (:POINTER :MOVIERECORD)) (PREVIEWTIME :SIGNED-LONG) (PREVIEWDURATION :SIGNED-LONG))
   NIL
   (:STACK-TRAP #xAAAA :D0 52 M PREVIEWTIME PREVIEWDURATION))


(deftrap _GETMOVIEPOSTERTIME ((M (:POINTER :MOVIERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 53 M))

(deftrap _SETMOVIEPOSTERTIME ((M (:POINTER :MOVIERECORD)) (POSTERTIME :SIGNED-LONG))
   NIL
   (:STACK-TRAP #xAAAA :D0 54 M POSTERTIME))


(deftrap _GETMOVIESELECTION ((M (:POINTER :MOVIERECORD)) (SELECTIONTIME (:POINTER :SIGNED-LONG)) (SELECTIONDURATION (:POINTER :SIGNED-LONG)))
   NIL
   (:STACK-TRAP #xAAAA :D0 55 M SELECTIONTIME SELECTIONDURATION))

(deftrap _SETMOVIESELECTION ((M (:POINTER :MOVIERECORD)) (SELECTIONTIME :SIGNED-LONG) (SELECTIONDURATION :SIGNED-LONG))
   NIL
   (:STACK-TRAP #xAAAA :D0 56 M SELECTIONTIME SELECTIONDURATION))


(deftrap _SETMOVIEACTIVESEGMENT ((M (:POINTER :MOVIERECORD)) (STARTTIME :SIGNED-LONG) (DURATION :SIGNED-LONG))
   NIL
   (:STACK-TRAP #xAAAA :D0 348 M STARTTIME DURATION))

(deftrap _GETMOVIEACTIVESEGMENT ((M (:POINTER :MOVIERECORD)) (STARTTIME (:POINTER :SIGNED-LONG)) (DURATION (:POINTER :SIGNED-LONG)))
   NIL
   (:STACK-TRAP #xAAAA :D0 349 M STARTTIME DURATION))


(deftrap _GETMOVIETIME ((M (:POINTER :MOVIERECORD)) (CURRENTTIME (:POINTER :TIMERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 57 M CURRENTTIME))

(deftrap _SETMOVIETIME ((M (:POINTER :MOVIERECORD)) (NEWTIME :TIMERECORD))
   NIL
   (:STACK-TRAP #xAAAA :D0 60 M NEWTIME))

(deftrap _SETMOVIETIMEVALUE ((M (:POINTER :MOVIERECORD)) (NEWTIME :SIGNED-LONG))
   NIL
   (:STACK-TRAP #xAAAA :D0 61 M NEWTIME))


(deftrap _GETMOVIEUSERDATA ((M (:POINTER :MOVIERECORD)))
   (:STACK (:POINTER :USERDATARECORD))
   (:STACK-TRAP #xAAAA :D0 62 M))


(deftrap _SETMOVIEPLAYHINTS ((MOVIE (:POINTER :MOVIERECORD)) (FLAGS :SIGNED-LONG) (FLAGSMASK :SIGNED-LONG))
   NIL
   (:STACK-TRAP #xAAAA :D0 417 MOVIE FLAGS FLAGSMASK))

;   Movie/Track/Media finding Routines  

(deftrap _GETMOVIETRACKCOUNT ((M (:POINTER :MOVIERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 63 M))

(deftrap _GETMOVIETRACK ((M (:POINTER :MOVIERECORD)) (TRACKID :SIGNED-LONG))
   (:STACK (:POINTER :TRACKRECORD))
   (:STACK-TRAP #xAAAA :D0 64 M TRACKID))


(deftrap _GETMOVIEINDTRACK ((M (:POINTER :MOVIERECORD)) (INDEX :SIGNED-LONG))
   (:STACK (:POINTER :TRACKRECORD))
   (:STACK-TRAP #xAAAA :D0 279 M INDEX))


(deftrap _GETTRACKID ((T (:POINTER :TRACKRECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 295 T))


(deftrap _GETTRACKMOVIE ((T (:POINTER :TRACKRECORD)))
   (:STACK (:POINTER :MOVIERECORD))
   (:STACK-TRAP #xAAAA :D0 208 T))


(deftrap _GETTRACKMEDIA ((T (:POINTER :TRACKRECORD)))
   (:STACK (:POINTER :MEDIARECORD))
   (:STACK-TRAP #xAAAA :D0 98 T))

(deftrap _GETMEDIATRACK ((M (:POINTER :MEDIARECORD)))
   (:STACK (:POINTER :TRACKRECORD))
   (:STACK-TRAP #xAAAA :D0 197 M))

;   Track creation Routines  

(deftrap _NEWMOVIETRACK ((M (:POINTER :MOVIERECORD)) (WIDTH :SIGNED-LONG) (HEIGHT :SIGNED-LONG) (TRACKVOLUME :SIGNED-INTEGER))
   (:STACK (:POINTER :TRACKRECORD))
   (:STACK-TRAP #xAAAA :D0 392 M WIDTH HEIGHT TRACKVOLUME))

(deftrap _DISPOSEMOVIETRACK ((T (:POINTER :TRACKRECORD)))
   NIL
   (:STACK-TRAP #xAAAA :D0 66 T))

;   Track Routines  

(deftrap _GETTRACKCREATIONTIME ((T (:POINTER :TRACKRECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 67 T))

(deftrap _GETTRACKMODIFICATIONTIME ((T (:POINTER :TRACKRECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 68 T))


(deftrap _GETTRACKENABLED ((T (:POINTER :TRACKRECORD)))
   (:STACK :BOOLEAN)
   (:STACK-TRAP #xAAAA :D0 69 T))

(deftrap _SETTRACKENABLED ((T (:POINTER :TRACKRECORD)) (ISENABLED :BOOLEAN))
   NIL
   (:STACK-TRAP #xAAAA :D0 70 T ISENABLED))


(deftrap _GETTRACKUSAGE ((T (:POINTER :TRACKRECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 71 T))

(deftrap _SETTRACKUSAGE ((T (:POINTER :TRACKRECORD)) (USAGE :SIGNED-LONG))
   NIL
   (:STACK-TRAP #xAAAA :D0 72 T USAGE))


(deftrap _GETTRACKDURATION ((T (:POINTER :TRACKRECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 75 T))


(deftrap _GETTRACKOFFSET ((T (:POINTER :TRACKRECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 76 T))

(deftrap _SETTRACKOFFSET ((T (:POINTER :TRACKRECORD)) (OFFSET :SIGNED-LONG))
   NIL
   (:STACK-TRAP #xAAAA :D0 77 T OFFSET))


(deftrap _GETTRACKLAYER ((T (:POINTER :TRACKRECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 80 T))

(deftrap _SETTRACKLAYER ((T (:POINTER :TRACKRECORD)) (LAYER :SIGNED-INTEGER))
   NIL
   (:STACK-TRAP #xAAAA :D0 81 T LAYER))


(deftrap _GETTRACKALTERNATE ((T (:POINTER :TRACKRECORD)))
   (:STACK (:POINTER :TRACKRECORD))
   (:STACK-TRAP #xAAAA :D0 82 T))

(deftrap _SETTRACKALTERNATE ((T (:POINTER :TRACKRECORD)) (ALTERNATET (:POINTER :TRACKRECORD)))
   NIL
   (:STACK-TRAP #xAAAA :D0 83 T ALTERNATET))


(deftrap _GETTRACKVOLUME ((T (:POINTER :TRACKRECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 84 T))

(deftrap _SETTRACKVOLUME ((T (:POINTER :TRACKRECORD)) (VOLUME :SIGNED-INTEGER))
   NIL
   (:STACK-TRAP #xAAAA :D0 85 T VOLUME))


(deftrap _GETTRACKMATRIX ((T (:POINTER :TRACKRECORD)) (MATRIX (:POINTER :MATRIXRECORD)))
   NIL
   (:STACK-TRAP #xAAAA :D0 86 T MATRIX))

(deftrap _SETTRACKMATRIX ((T (:POINTER :TRACKRECORD)) (MATRIX :MATRIXRECORD))
   NIL
   (:STACK-TRAP #xAAAA :D0 87 T MATRIX))


(deftrap _GETTRACKDIMENSIONS ((T (:POINTER :TRACKRECORD)) (WIDTH (:POINTER :SIGNED-LONG)) (HEIGHT (:POINTER :SIGNED-LONG)))
   NIL
   (:STACK-TRAP #xAAAA :D0 93 T WIDTH HEIGHT))

(deftrap _SETTRACKDIMENSIONS ((T (:POINTER :TRACKRECORD)) (WIDTH :SIGNED-LONG) (HEIGHT :SIGNED-LONG))
   NIL
   (:STACK-TRAP #xAAAA :D0 94 T WIDTH HEIGHT))


(deftrap _GETTRACKUSERDATA ((T (:POINTER :TRACKRECORD)))
   (:STACK (:POINTER :USERDATARECORD))
   (:STACK-TRAP #xAAAA :D0 95 T))

;   Media creation Routines  

(deftrap _NEWTRACKMEDIA ((T (:POINTER :TRACKRECORD)) (MEDIATYPE :OSTYPE) (TIMESCALE :SIGNED-LONG) (DATAREF :HANDLE) (DATAREFTYPE :OSTYPE))
   (:STACK (:POINTER :MEDIARECORD))
   (:STACK-TRAP #xAAAA :D0 398 T MEDIATYPE TIMESCALE DATAREF DATAREFTYPE))

(deftrap _DISPOSETRACKMEDIA ((M (:POINTER :MEDIARECORD)))
   NIL
   (:STACK-TRAP #xAAAA :D0 97 M))

;   Media Routines  

(deftrap _GETMEDIACREATIONTIME ((M (:POINTER :MEDIARECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 102 M))

(deftrap _GETMEDIAMODIFICATIONTIME ((M (:POINTER :MEDIARECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 103 M))


(deftrap _GETMEDIATIMESCALE ((M (:POINTER :MEDIARECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 104 M))

(deftrap _SETMEDIATIMESCALE ((M (:POINTER :MEDIARECORD)) (TIMESCALE :SIGNED-LONG))
   NIL
   (:STACK-TRAP #xAAAA :D0 105 M TIMESCALE))


(deftrap _GETMEDIADURATION ((M (:POINTER :MEDIARECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 106 M))


(deftrap _GETMEDIALANGUAGE ((M (:POINTER :MEDIARECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 107 M))

(deftrap _SETMEDIALANGUAGE ((M (:POINTER :MEDIARECORD)) (LANGUAGE :SIGNED-INTEGER))
   NIL
   (:STACK-TRAP #xAAAA :D0 108 M LANGUAGE))


(deftrap _GETMEDIAQUALITY ((M (:POINTER :MEDIARECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 109 M))

(deftrap _SETMEDIAQUALITY ((M (:POINTER :MEDIARECORD)) (QUALITY :SIGNED-INTEGER))
   NIL
   (:STACK-TRAP #xAAAA :D0 110 M QUALITY))


(deftrap _GETMEDIAUSERDATA ((M (:POINTER :MEDIARECORD)))
   (:STACK (:POINTER :USERDATARECORD))
   (:STACK-TRAP #xAAAA :D0 112 M))


(deftrap _SETMEDIAPLAYHINTS ((MOVIE (:POINTER :MOVIERECORD)) (FLAGS :SIGNED-LONG) (FLAGSMASK :SIGNED-LONG))
   NIL
   (:STACK-TRAP #xAAAA :D0 418 MOVIE FLAGS FLAGSMASK))

;   Media Handler Routines  

(deftrap _GETMEDIAHANDLER ((M (:POINTER :MEDIARECORD)))
   (:STACK (:POINTER :COMPONENTINSTANCERECORD))
   (:STACK-TRAP #xAAAA :D0 113 M))

(deftrap _SETMEDIAHANDLER ((M (:POINTER :MEDIARECORD)) (MH (:POINTER :COMPONENTRECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 400 M MH))


(deftrap _GETMEDIAHANDLERDESCRIPTION ((M (:POINTER :MEDIARECORD)) (MEDIATYPE (:POINTER :OSTYPE)) (CREATORNAME (:POINTER (:STRING 255))) (CREATORMANUFACTURER (:POINTER :OSTYPE)))
   NIL
   (:STACK-TRAP #xAAAA :D0 111 M MEDIATYPE CREATORNAME CREATORMANUFACTURER))

(defconstant $dataRefSelfReference 1)
(defconstant $dataRefWasNotResolved 2)

;   Media dataRef Routines  

(deftrap _GETMEDIADATAREF ((M (:POINTER :MEDIARECORD)) (INDEX :SIGNED-INTEGER) (DATAREF (:POINTER :HANDLE)) (DATAREFTYPE (:POINTER :OSTYPE)) (DATAREFATTRIBUTES (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 407 M INDEX DATAREF DATAREFTYPE DATAREFATTRIBUTES))

(deftrap _ADDMEDIADATAREF ((M (:POINTER :MEDIARECORD)) (INDEX (:POINTER :SIGNED-INTEGER)) (DATAREF :HANDLE) (DATAREFTYPE :OSTYPE))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 408 M INDEX DATAREF DATAREFTYPE))


(deftrap _GETMEDIADATAREFCOUNT ((M (:POINTER :MEDIARECORD)) (COUNT (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 409 M COUNT))

;   Media data handler Routines  

(deftrap _GETMEDIADATAHANDLER ((M (:POINTER :MEDIARECORD)) (INDEX :SIGNED-INTEGER))
   (:STACK (:POINTER :COMPONENTINSTANCERECORD))
   (:STACK-TRAP #xAAAA :D0 415 M INDEX))

(deftrap _SETMEDIADATAHANDLER ((M (:POINTER :MEDIARECORD)) (INDEX :SIGNED-INTEGER) (DATAHANDLER (:POINTER :COMPONENTRECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 416 M INDEX DATAHANDLER))


(deftrap _GETMEDIADATAHANDLERDESCRIPTION ((M (:POINTER :MEDIARECORD)) (INDEX :SIGNED-INTEGER) (DHTYPE (:POINTER :OSTYPE)) (CREATORNAME (:POINTER (:STRING 255))) (CREATORMANUFACTURER (:POINTER :OSTYPE)))
   NIL
   (:STACK-TRAP #xAAAA :D0 414 M INDEX DHTYPE CREATORNAME CREATORMANUFACTURER))

;   Media sample Routines  

(deftrap _GETMEDIASAMPLEDESCRIPTIONCOUNT ((M (:POINTER :MEDIARECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 119 M))

(deftrap _GETMEDIASAMPLEDESCRIPTION ((M (:POINTER :MEDIARECORD)) (INDEX :SIGNED-LONG) (DESCH (:HANDLE :SAMPLEDESCRIPTION)))
   NIL
   (:STACK-TRAP #xAAAA :D0 120 M INDEX DESCH))

(deftrap _GETMEDIASAMPLECOUNT ((M (:POINTER :MEDIARECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 121 M))

(deftrap _SAMPLENUMTOMEDIATIME ((M (:POINTER :MEDIARECORD)) (LOGICALSAMPLENUM :SIGNED-LONG) (SAMPLETIME (:POINTER :SIGNED-LONG)) (SAMPLEDURATION (:POINTER :SIGNED-LONG)))
   NIL
   (:STACK-TRAP #xAAAA :D0 122 M LOGICALSAMPLENUM SAMPLETIME SAMPLEDURATION))

(deftrap _MEDIATIMETOSAMPLENUM ((M (:POINTER :MEDIARECORD)) (TIME :SIGNED-LONG) (SAMPLENUM (:POINTER :SIGNED-LONG)) (SAMPLETIME (:POINTER :SIGNED-LONG)) (SAMPLEDURATION (:POINTER :SIGNED-LONG)))
   NIL
   (:STACK-TRAP #xAAAA :D0 123 M TIME SAMPLENUM SAMPLETIME SAMPLEDURATION))


(deftrap _ADDMEDIASAMPLE ((M (:POINTER :MEDIARECORD)) (DATAIN :HANDLE) (INOFFSET :SIGNED-LONG) (SIZE :SIGNED-LONG) (DURATIONPERSAMPLE :SIGNED-LONG) (SAMPLEDESCRIPTIONH (:HANDLE :SAMPLEDESCRIPTION)) (NUMBEROFSAMPLES :SIGNED-LONG) (SAMPLEFLAGS :SIGNED-INTEGER) (SAMPLETIME (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 124 M DATAIN INOFFSET SIZE DURATIONPERSAMPLE SAMPLEDESCRIPTIONH NUMBEROFSAMPLES SAMPLEFLAGS SAMPLETIME))

(deftrap _ADDMEDIASAMPLEREFERENCE ((M (:POINTER :MEDIARECORD)) (DATAOFFSET :SIGNED-LONG) (SIZE :SIGNED-LONG) (DURATIONPERSAMPLE :SIGNED-LONG) (SAMPLEDESCRIPTIONH (:HANDLE :SAMPLEDESCRIPTION)) (NUMBEROFSAMPLES :SIGNED-LONG) (SAMPLEFLAGS :SIGNED-INTEGER) (SAMPLETIME (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 125 M DATAOFFSET SIZE DURATIONPERSAMPLE SAMPLEDESCRIPTIONH NUMBEROFSAMPLES SAMPLEFLAGS SAMPLETIME))

(deftrap _GETMEDIASAMPLE ((M (:POINTER :MEDIARECORD)) (DATAOUT :HANDLE) (MAXSIZETOGROW :SIGNED-LONG) (SIZE (:POINTER :SIGNED-LONG)) (TIME :SIGNED-LONG) (SAMPLETIME (:POINTER :SIGNED-LONG)) (DURATIONPERSAMPLE (:POINTER :SIGNED-LONG)) (SAMPLEDESCRIPTIONH (:HANDLE :SAMPLEDESCRIPTION)) (SAMPLEDESCRIPTIONINDEX (:POINTER :SIGNED-LONG)) (MAXNUMBEROFSAMPLES :SIGNED-LONG) (NUMBEROFSAMPLES (:POINTER :SIGNED-LONG)) (SAMPLEFLAGS (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 126 M DATAOUT MAXSIZETOGROW SIZE TIME SAMPLETIME DURATIONPERSAMPLE SAMPLEDESCRIPTIONH SAMPLEDESCRIPTIONINDEX MAXNUMBEROFSAMPLES NUMBEROFSAMPLES SAMPLEFLAGS))

(deftrap _GETMEDIASAMPLEREFERENCE ((M (:POINTER :MEDIARECORD)) (DATAOFFSET (:POINTER :SIGNED-LONG)) (SIZE (:POINTER :SIGNED-LONG)) (TIME :SIGNED-LONG) (SAMPLETIME (:POINTER :SIGNED-LONG)) (DURATIONPERSAMPLE (:POINTER :SIGNED-LONG)) (SAMPLEDESCRIPTIONH (:HANDLE :SAMPLEDESCRIPTION)) (SAMPLEDESCRIPTIONINDEX (:POINTER :SIGNED-LONG)) (MAXNUMBEROFSAMPLES :SIGNED-LONG) (NUMBEROFSAMPLES (:POINTER :SIGNED-LONG)) (SAMPLEFLAGS (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 127 M DATAOFFSET SIZE TIME SAMPLETIME DURATIONPERSAMPLE SAMPLEDESCRIPTIONH SAMPLEDESCRIPTIONINDEX MAXNUMBEROFSAMPLES NUMBEROFSAMPLES SAMPLEFLAGS))

;   High level editing Routines  

(deftrap _CUTMOVIESELECTION ((M (:POINTER :MOVIERECORD)))
   (:STACK (:POINTER :MOVIERECORD))
   (:STACK-TRAP #xAAAA :D0 141 M))

(deftrap _COPYMOVIESELECTION ((M (:POINTER :MOVIERECORD)))
   (:STACK (:POINTER :MOVIERECORD))
   (:STACK-TRAP #xAAAA :D0 142 M))

(deftrap _PASTEMOVIESELECTION ((M (:POINTER :MOVIERECORD)) (SRC (:POINTER :MOVIERECORD)))
   NIL
   (:STACK-TRAP #xAAAA :D0 143 M SRC))

(deftrap _ADDMOVIESELECTION ((M (:POINTER :MOVIERECORD)) (SRC (:POINTER :MOVIERECORD)))
   NIL
   (:STACK-TRAP #xAAAA :D0 338 M SRC))

(deftrap _CLEARMOVIESELECTION ((M (:POINTER :MOVIERECORD)))
   NIL
   (:STACK-TRAP #xAAAA :D0 225 M))

;   Middle-level Editing Routines  

(deftrap _INSERTTRACKSEGMENT ((SRCTRACK (:POINTER :TRACKRECORD)) (DSTTRACK (:POINTER :TRACKRECORD)) (SRCIN :SIGNED-LONG) (SRCDURATION :SIGNED-LONG) (DSTIN :SIGNED-LONG))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 133 SRCTRACK DSTTRACK SRCIN SRCDURATION DSTIN))

(deftrap _INSERTMOVIESEGMENT ((SRCMOVIE (:POINTER :MOVIERECORD)) (DSTMOVIE (:POINTER :MOVIERECORD)) (SRCIN :SIGNED-LONG) (SRCDURATION :SIGNED-LONG) (DSTIN :SIGNED-LONG))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 134 SRCMOVIE DSTMOVIE SRCIN SRCDURATION DSTIN))

(deftrap _INSERTEMPTYTRACKSEGMENT ((DSTTRACK (:POINTER :TRACKRECORD)) (DSTIN :SIGNED-LONG) (DSTDURATION :SIGNED-LONG))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 135 DSTTRACK DSTIN DSTDURATION))

(deftrap _INSERTEMPTYMOVIESEGMENT ((DSTMOVIE (:POINTER :MOVIERECORD)) (DSTIN :SIGNED-LONG) (DSTDURATION :SIGNED-LONG))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 136 DSTMOVIE DSTIN DSTDURATION))

(deftrap _DELETETRACKSEGMENT ((T (:POINTER :TRACKRECORD)) (DSTIN :SIGNED-LONG) (DURATION :SIGNED-LONG))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 137 T DSTIN DURATION))

(deftrap _DELETEMOVIESEGMENT ((M (:POINTER :MOVIERECORD)) (DSTIN :SIGNED-LONG) (DURATION :SIGNED-LONG))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 138 M DSTIN DURATION))

(deftrap _SCALETRACKSEGMENT ((T (:POINTER :TRACKRECORD)) (DSTIN :SIGNED-LONG) (OLDDURATION :SIGNED-LONG) (NEWDURATION :SIGNED-LONG))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 139 T DSTIN OLDDURATION NEWDURATION))

(deftrap _SCALEMOVIESEGMENT ((M (:POINTER :MOVIERECORD)) (DSTIN :SIGNED-LONG) (OLDDURATION :SIGNED-LONG) (NEWDURATION :SIGNED-LONG))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 140 M DSTIN OLDDURATION NEWDURATION))


(deftrap _COPYTRACKSETTINGS ((SRCTRACK (:POINTER :TRACKRECORD)) (DSTTRACK (:POINTER :TRACKRECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 339 SRCTRACK DSTTRACK))

(deftrap _COPYMOVIESETTINGS ((SRCMOVIE (:POINTER :MOVIERECORD)) (DSTMOVIE (:POINTER :MOVIERECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 340 SRCMOVIE DSTMOVIE))

;   low-level Editing Routines  

(deftrap _INSERTMEDIAINTOTRACK ((T (:POINTER :TRACKRECORD)) (TRACKSTART :SIGNED-LONG) (MEDIATIME :SIGNED-LONG) (MEDIADURATION :SIGNED-LONG) (MEDIARATE :SIGNED-LONG))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 387 T TRACKSTART MEDIATIME MEDIADURATION MEDIARATE))


(deftrap _BEGINMEDIAEDITS ((M (:POINTER :MEDIARECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 114 M))

(deftrap _ENDMEDIAEDITS ((M (:POINTER :MEDIARECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 115 M))

;   movie & track edit state Routines  

(deftrap _NEWMOVIEEDITSTATE ((M (:POINTER :MOVIERECORD)))
   (:STACK (:POINTER :MOVIEEDITSTATERECORD))
   (:STACK-TRAP #xAAAA :D0 260 M))

(deftrap _USEMOVIEEDITSTATE ((M (:POINTER :MOVIERECORD)) (TOSTATE (:POINTER :MOVIEEDITSTATERECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 261 M TOSTATE))

(deftrap _DISPOSEMOVIEEDITSTATE ((STATE (:POINTER :MOVIEEDITSTATERECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 262 STATE))


(deftrap _NEWTRACKEDITSTATE ((T (:POINTER :TRACKRECORD)))
   (:STACK (:POINTER :TRACKEDITSTATERECORD))
   (:STACK-TRAP #xAAAA :D0 263 T))

(deftrap _USETRACKEDITSTATE ((T (:POINTER :TRACKRECORD)) (STATE (:POINTER :TRACKEDITSTATERECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 264 T STATE))

(deftrap _DISPOSETRACKEDITSTATE ((STATE (:POINTER :TRACKEDITSTATERECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 265 STATE))

;   Miscellaneous Routines  

(deftrap _TRACKTIMETOMEDIATIME ((VALUE :SIGNED-LONG) (T (:POINTER :TRACKRECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 150 VALUE T))


(deftrap _GETMOVIEDATASIZE ((M (:POINTER :MOVIERECORD)) (STARTTIME :SIGNED-LONG) (DURATION :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 152 M STARTTIME DURATION))

(deftrap _GETTRACKDATASIZE ((T (:POINTER :TRACKRECORD)) (STARTTIME :SIGNED-LONG) (DURATION :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 329 T STARTTIME DURATION))

(deftrap _GETMEDIADATASIZE ((M (:POINTER :MEDIARECORD)) (STARTTIME :SIGNED-LONG) (DURATION :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 153 M STARTTIME DURATION))


(deftrap _PTINMOVIE ((M (:POINTER :MOVIERECORD)) (PT :POINT))
   (:STACK :BOOLEAN)
   (:STACK-TRAP #xAAAA :D0 154 M PT))

(deftrap _PTINTRACK ((T (:POINTER :TRACKRECORD)) (PT :POINT))
   (:STACK :BOOLEAN)
   (:STACK-TRAP #xAAAA :D0 155 T PT))


(deftrap _UPDATEMOVIE ((M (:POINTER :MOVIERECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 31 M))

;   Alternate Group Selection Routines  

(deftrap _SETMOVIELANGUAGE ((M (:POINTER :MOVIERECORD)) (LANGUAGE :SIGNED-LONG))
   NIL
   (:STACK-TRAP #xAAAA :D0 156 M LANGUAGE))


(deftrap _SETAUTOTRACKALTERNATESENABLED ((M (:POINTER :MOVIERECORD)) (ENABLE :BOOLEAN))
   NIL
   (:STACK-TRAP #xAAAA :D0 350 M ENABLE))

(deftrap _SELECTMOVIEALTERNATES ((M (:POINTER :MOVIERECORD)))
   NIL
   (:STACK-TRAP #xAAAA :D0 351 M))

;   UserData Routines  

(deftrap _GETUSERDATA ((U (:POINTER :USERDATARECORD)) (DATA :HANDLE) (UDTYPE :OSTYPE) (INDEX :SIGNED-LONG))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 158 U DATA UDTYPE INDEX))

(deftrap _ADDUSERDATA ((U (:POINTER :USERDATARECORD)) (DATA :HANDLE) (UDTYPE :OSTYPE))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 159 U DATA UDTYPE))

(deftrap _REMOVEUSERDATA ((U (:POINTER :USERDATARECORD)) (UDTYPE :OSTYPE) (INDEX :SIGNED-LONG))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 160 U UDTYPE INDEX))

(deftrap _COUNTUSERDATATYPE ((USERDATAH (:POINTER :USERDATARECORD)) (UDTYPE :OSTYPE))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 331 USERDATAH UDTYPE))

(deftrap _ADDUSERDATATEXT ((U (:POINTER :USERDATARECORD)) (DATA :HANDLE) (UDTYPE :OSTYPE) (INDEX :SIGNED-LONG) (ITLREGIONTAG :SIGNED-INTEGER))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 332 U DATA UDTYPE INDEX ITLREGIONTAG))

(deftrap _GETUSERDATATEXT ((U (:POINTER :USERDATARECORD)) (DATA :HANDLE) (UDTYPE :OSTYPE) (INDEX :SIGNED-LONG) (ITLREGIONTAG :SIGNED-INTEGER))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 333 U DATA UDTYPE INDEX ITLREGIONTAG))

(deftrap _REMOVEUSERDATATEXT ((U (:POINTER :USERDATARECORD)) (UDTYPE :OSTYPE) (INDEX :SIGNED-LONG) (ITLREGIONTAG :SIGNED-INTEGER))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 334 U UDTYPE INDEX ITLREGIONTAG))

;   interesting time Routines  

(deftrap _GETMEDIANEXTINTERESTINGTIME ((M (:POINTER :MEDIARECORD)) (INTERESTINGTIMEFLAGS :SIGNED-INTEGER) (TIME :SIGNED-LONG) (RATE :SIGNED-LONG) (INTERESTINGTIME (:POINTER :SIGNED-LONG)) (INTERESTINGDURATION (:POINTER :SIGNED-LONG)))
   NIL
   (:STACK-TRAP #xAAAA :D0 365 M INTERESTINGTIMEFLAGS TIME RATE INTERESTINGTIME INTERESTINGDURATION))

(deftrap _GETTRACKNEXTINTERESTINGTIME ((T (:POINTER :TRACKRECORD)) (INTERESTINGTIMEFLAGS :SIGNED-INTEGER) (TIME :SIGNED-LONG) (RATE :SIGNED-LONG) (INTERESTINGTIME (:POINTER :SIGNED-LONG)) (INTERESTINGDURATION (:POINTER :SIGNED-LONG)))
   NIL
   (:STACK-TRAP #xAAAA :D0 226 T INTERESTINGTIMEFLAGS TIME RATE INTERESTINGTIME INTERESTINGDURATION))

(deftrap _GETMOVIENEXTINTERESTINGTIME ((M (:POINTER :MOVIERECORD)) (INTERESTINGTIMEFLAGS :SIGNED-INTEGER) (NUMMEDIATYPES :SIGNED-INTEGER) (WHICHMEDIATYPES :POINTER) (TIME :SIGNED-LONG) (RATE :SIGNED-LONG) (INTERESTINGTIME (:POINTER :SIGNED-LONG)) (INTERESTINGDURATION (:POINTER :SIGNED-LONG)))
   NIL
   (:STACK-TRAP #xAAAA :D0 270 M INTERESTINGTIMEFLAGS NUMMEDIATYPES WHICHMEDIATYPES TIME RATE INTERESTINGTIME INTERESTINGDURATION))

;   movie file Routines  

(deftrap _CREATEMOVIEFILE ((FILESPEC :FSSPEC) (CREATOR :OSTYPE) (SCRIPTTAG :SIGNED-INTEGER) (CREATEMOVIEFILEFLAGS :SIGNED-LONG) (RESREFNUM (:POINTER :SIGNED-INTEGER)) (NEWMOVIE (:POINTER (:POINTER :MOVIERECORD))))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 401 FILESPEC CREATOR SCRIPTTAG CREATEMOVIEFILEFLAGS RESREFNUM NEWMOVIE))

(deftrap _DELETEMOVIEFILE ((FILESPEC :FSSPEC))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 373 FILESPEC))


(deftrap _OPENMOVIEFILE ((FILESPEC :FSSPEC) (RESREFNUM (:POINTER :SIGNED-INTEGER)) (PERMS :SIGNED-BYTE))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 402 FILESPEC RESREFNUM PERMS))

(deftrap _CLOSEMOVIEFILE ((RESREFNUM :SIGNED-INTEGER))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 213 RESREFNUM))

(defconstant $movieInDataForkResID -1);  magic res ID 


(deftrap _NEWMOVIEFROMFILE ((M (:POINTER (:POINTER :MOVIERECORD))) (RESREFNUM :SIGNED-INTEGER) (RESID (:POINTER :SIGNED-INTEGER)) (RESNAME (:STRING 255)) (NEWMOVIEFLAGS :SIGNED-INTEGER) (DATAREFWASCHANGED (:POINTER :BOOLEAN)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 240 M RESREFNUM RESID RESNAME NEWMOVIEFLAGS DATAREFWASCHANGED))


(deftrap _ADDMOVIERESOURCE ((M (:POINTER :MOVIERECORD)) (RESREFNUM :SIGNED-INTEGER) (RESID (:POINTER :SIGNED-INTEGER)) (RESNAME (:STRING 255)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 215 M RESREFNUM RESID RESNAME))

(deftrap _REMOVEMOVIERESOURCE ((RESREFNUM :SIGNED-INTEGER) (RESID :SIGNED-INTEGER))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 374 RESREFNUM RESID))

(deftrap _UPDATEMOVIERESOURCE ((M (:POINTER :MOVIERECORD)) (RESREFNUM :SIGNED-INTEGER) (RESID :SIGNED-INTEGER) (RESNAME (:STRING 255)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 216 M RESREFNUM RESID RESNAME))


(deftrap _HASMOVIECHANGED ((M (:POINTER :MOVIERECORD)))
   (:STACK :BOOLEAN)
   (:STACK-TRAP #xAAAA :D0 217 M))

(deftrap _CLEARMOVIECHANGED ((M (:POINTER :MOVIERECORD)))
   NIL
   (:STACK-TRAP #xAAAA :D0 275 M))


(deftrap _FLATTENMOVIE ((M (:POINTER :MOVIERECORD)) (MOVIEFLATTENFLAGS :SIGNED-LONG) (THEFILE :FSSPEC) (CREATOR :OSTYPE) (SCRIPTTAG :SIGNED-INTEGER) (CREATEMOVIEFILEFLAGS :SIGNED-LONG) (RESID (:POINTER :SIGNED-INTEGER)) (RESNAME (:STRING 255)))
   NIL
   (:STACK-TRAP #xAAAA :D0 411 M MOVIEFLATTENFLAGS THEFILE CREATOR SCRIPTTAG CREATEMOVIEFILEFLAGS RESID RESNAME))

(deftrap _FLATTENMOVIEDATA ((M (:POINTER :MOVIERECORD)) (MOVIEFLATTENFLAGS :SIGNED-LONG) (THEFILE :FSSPEC) (CREATOR :OSTYPE) (SCRIPTTAG :SIGNED-INTEGER) (CREATEMOVIEFILEFLAGS :SIGNED-LONG))
   (:STACK (:POINTER :MOVIERECORD))
   (:STACK-TRAP #xAAAA :D0 412 M MOVIEFLATTENFLAGS THEFILE CREATOR SCRIPTTAG CREATEMOVIEFILEFLAGS))

(deftrap _SETMOVIEPROGRESSPROC ((M (:POINTER :MOVIERECORD)) (P :POINTER) (REFCON :SIGNED-LONG))
   NIL
   (:STACK-TRAP #xAAAA :D0 410 M P REFCON))


(deftrap _PUTMOVIEONSCRAP ((M (:POINTER :MOVIERECORD)) (MOVIESCRAPFLAGS :SIGNED-LONG))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 396 M MOVIESCRAPFLAGS))

(deftrap _NEWMOVIEFROMSCRAP ((NEWMOVIEFLAGS :SIGNED-LONG))
   (:STACK (:POINTER :MOVIERECORD))
   (:STACK-TRAP #xAAAA :D0 397 NEWMOVIEFLAGS))

;   Video Media Routines  

(deftrap _GETVIDEOMEDIAGRAPHICSMODE ((MH (:POINTER :COMPONENTINSTANCERECORD)) (GRAPHICSMODE (:POINTER :SIGNED-LONG)) (OPCOLOR (:POINTER :RGBCOLOR)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MH GRAPHICSMODE OPCOLOR ((+ (ASH 8 16) 257) :SIGNED-LONGINT)))

(deftrap _SETVIDEOMEDIAGRAPHICSMODE ((MH (:POINTER :COMPONENTINSTANCERECORD)) (GRAPHICSMODE :SIGNED-LONG) (OPCOLOR :RGBCOLOR))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MH GRAPHICSMODE OPCOLOR ((+ (ASH 8 16) 258) :SIGNED-LONGINT)))

;   Sound Media Routines  

(deftrap _GETSOUNDMEDIABALANCE ((MH (:POINTER :COMPONENTINSTANCERECORD)) (BALANCE (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MH BALANCE ((+ (ASH 4 16) 257) :SIGNED-LONGINT)))

(deftrap _SETSOUNDMEDIABALANCE ((MH (:POINTER :COMPONENTINSTANCERECORD)) (BALANCE :SIGNED-INTEGER))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MH BALANCE ((+ (ASH 2 16) 258) :SIGNED-LONGINT)))

(defconstant $couldNotResolveDataRef -2000)
(defconstant $badImageDescription -2001)
(defconstant $badPublicMovieAtom -2002)
(defconstant $cantFindHandler -2003)
(defconstant $cantOpenHandler -2004)
(defconstant $badComponentType -2005)
(defconstant $noMediaHandler -2006)
(defconstant $noDataHandler -2007)
(defconstant $invalidMedia -2008)
(defconstant $invalidTrack -2009)
(defconstant $invalidMovie -2010)
(defconstant $invalidSampleTable -2011)
(defconstant $invalidDataRef -2012)
(defconstant $invalidHandler -2013)
(defconstant $invalidDuration -2014)
(defconstant $invalidTime -2015)
(defconstant $cantPutPublicMovieAtom -2016)
(defconstant $badEditList -2017)
(defconstant $mediaTypesDontMatch -2018)
(defconstant $progressProcAborted -2019)
(defconstant $movieToolboxUnitialized -2020)
(defconstant $wfFileNotFound -2021)
(defconstant $cantCreateSingleForkFile -2022)
(defconstant $invalidEditState -2023)
(defconstant $nonMatchingEditState -2024)
(defconstant $staleEditState -2025)
(defconstant $userDataItemNotFound -2026)
(defconstant $maxSizeToGrowTooSmall -2027)
(defconstant $badTrackIndex -2028)
(defconstant $trackIDNotFound -2029)
(defconstant $trackNotInMovie -2030)
(defconstant $timeNotInTrack -2031)
(defconstant $timeNotInMedia -2032)
(defconstant $badEditIndex -2033)
(defconstant $internalQuickTimeError -2034)
(defconstant $cantEnableTrack -2035)
(defconstant $invalidRect -2036)
(defconstant $invalidSampleNum -2037)
(defconstant $invalidChunkNum -2038)
(defconstant $invalidSampleDescIndex -2039)
(defconstant $invalidChunkCache -2040)
(defconstant $invalidSampleDescription -2041)
(defconstant $dataNotOpenForRead -2042)
(defconstant $dataNotOpenForWrite -2043)
(defconstant $dataAlreadyOpenForWrite -2044)
(defconstant $dataAlreadyClosed -2045)
(defconstant $endOfDataReached -2046)
(defconstant $dataNoDataRef -2047)
(defconstant $noMovieFound -2048)
(defconstant $invalidDataRefContainer -2049)
(defconstant $badDataRefIndex -2050)
(defconstant $noDefaultDataRef -2051)
(defconstant $couldNotUseAnExistingSample -2052)
(defconstant $featureUnsupported -2053)

(defconstant $loopTimeBase 1)

;  TimeBase Routines 
(def-mactype :TIMEBASEFLAGS (find-mactype :CHARACTER))

(defconstant $triggerTimeFwd #X1);  when curTime exceeds triggerTime going forward 
(defconstant $triggerTimeBwd #X2);  when curTime exceeds triggerTime going backwards 
(defconstant $triggerTimeEither #X3);  when curTime exceeds triggerTime going either direction 
(defconstant $triggerRateLT #X4);  when rate changes to less than trigger value 
(defconstant $triggerRateGT #X8);  when rate changes to greater than trigger value 
(defconstant $triggerRateEqual #X10);  when rate changes to equal trigger value 
(defconstant $triggerRateLTE #X14)
(defconstant $triggerRateGTE #X18)
(defconstant $triggerRateNotEqual #X1C)
(defconstant $triggerRateChange 0)
(defconstant $timeBaseBeforeStartTime 1)
(defconstant $timeBaseAfterStopTime 2)
(defconstant $callBackAtTime 1)
(defconstant $callBackAtRate 2)
(defconstant $callBackAtTimeJump 3)
(defconstant $callBackAtInterrupt #X8000)

(def-mactype :QTCALLBACKPROC (find-mactype :POINTER))

(defconstant $qtcbNeedsRateChanges 1)
(defconstant $qtcbNeedsTimeChanges 2)

;  CallBack equates 
(defrecord QTCallBackHeader 
   (callBackFlags :SIGNED-LONG)
   (reserved1 :SIGNED-LONG)
   (qtPrivate (:ARRAY :UNSIGNED-BYTE 40))
   )

;   TimeBase Routines  

(deftrap _NEWTIMEBASE NIL
   (:STACK (:POINTER :TIMEBASERECORD))
   (:STACK-TRAP #xAAAA :D0 165))

(deftrap _DISPOSETIMEBASE ((TB (:POINTER :TIMEBASERECORD)))
   NIL
   (:STACK-TRAP #xAAAA :D0 182 TB))


(deftrap _GETTIMEBASETIME ((TB (:POINTER :TIMEBASERECORD)) (S :SIGNED-LONG) (OUT (:POINTER :TIMERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 166 TB S OUT))

(deftrap _SETTIMEBASETIME ((TB (:POINTER :TIMEBASERECORD)) (TR :TIMERECORD))
   NIL
   (:STACK-TRAP #xAAAA :D0 167 TB TR))

(deftrap _SETTIMEBASEVALUE ((TB (:POINTER :TIMEBASERECORD)) (T :SIGNED-LONG) (S :SIGNED-LONG))
   NIL
   (:STACK-TRAP #xAAAA :D0 168 TB T S))


(deftrap _GETTIMEBASERATE ((TB (:POINTER :TIMEBASERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 169 TB))

(deftrap _SETTIMEBASERATE ((TB (:POINTER :TIMEBASERECORD)) (R :SIGNED-LONG))
   NIL
   (:STACK-TRAP #xAAAA :D0 170 TB R))


(deftrap _GETTIMEBASESTARTTIME ((TB (:POINTER :TIMEBASERECORD)) (S :SIGNED-LONG) (OUT (:POINTER :TIMERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 171 TB S OUT))

(deftrap _SETTIMEBASESTARTTIME ((TB (:POINTER :TIMEBASERECORD)) (TR :TIMERECORD))
   NIL
   (:STACK-TRAP #xAAAA :D0 172 TB TR))

(deftrap _GETTIMEBASESTOPTIME ((TB (:POINTER :TIMEBASERECORD)) (S :SIGNED-LONG) (OUT (:POINTER :TIMERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 173 TB S OUT))

(deftrap _SETTIMEBASESTOPTIME ((TB (:POINTER :TIMEBASERECORD)) (TR :TIMERECORD))
   NIL
   (:STACK-TRAP #xAAAA :D0 174 TB TR))


(deftrap _GETTIMEBASEFLAGS ((TB (:POINTER :TIMEBASERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 177 TB))

(deftrap _SETTIMEBASEFLAGS ((TB (:POINTER :TIMEBASERECORD)) (TIMEBASEFLAGS :SIGNED-LONG))
   NIL
   (:STACK-TRAP #xAAAA :D0 178 TB TIMEBASEFLAGS))


(deftrap _SETTIMEBASEMASTERTIMEBASE ((SLAVE (:POINTER :TIMEBASERECORD)) (MASTER (:POINTER :TIMEBASERECORD)) (SLAVEZERO :TIMERECORD))
   NIL
   (:STACK-TRAP #xAAAA :D0 180 SLAVE MASTER SLAVEZERO))

(deftrap _GETTIMEBASEMASTERTIMEBASE ((TB (:POINTER :TIMEBASERECORD)))
   (:STACK (:POINTER :TIMEBASERECORD))
   (:STACK-TRAP #xAAAA :D0 175 TB))

(deftrap _SETTIMEBASEMASTERCLOCK ((SLAVE (:POINTER :TIMEBASERECORD)) (CLOCKMEISTER (:POINTER :COMPONENTRECORD)) (SLAVEZERO :TIMERECORD))
   NIL
   (:STACK-TRAP #xAAAA :D0 179 SLAVE CLOCKMEISTER SLAVEZERO))

(deftrap _GETTIMEBASEMASTERCLOCK ((TB (:POINTER :TIMEBASERECORD)))
   (:STACK (:POINTER :COMPONENTINSTANCERECORD))
   (:STACK-TRAP #xAAAA :D0 176 TB))


(deftrap _CONVERTTIME ((INOUT (:POINTER :TIMERECORD)) (NEWBASE (:POINTER :TIMEBASERECORD)))
   NIL
   (:STACK-TRAP #xAAAA :D0 181 INOUT NEWBASE))

(deftrap _CONVERTTIMESCALE ((INOUT (:POINTER :TIMERECORD)) (NEWSCALE :SIGNED-LONG))
   NIL
   (:STACK-TRAP #xAAAA :D0 183 INOUT NEWSCALE))

(deftrap _ADDTIME ((DST (:POINTER :TIMERECORD)) (SRC :TIMERECORD))
   NIL
   (:STACK-TRAP #xAAAA :D0 268 DST SRC))

(deftrap _SUBTRACTTIME ((DST (:POINTER :TIMERECORD)) (SRC :TIMERECORD))
   NIL
   (:STACK-TRAP #xAAAA :D0 269 DST SRC))


(deftrap _GETTIMEBASESTATUS ((TB (:POINTER :TIMEBASERECORD)) (UNPINNEDTIME (:POINTER :TIMERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xAAAA :D0 267 TB UNPINNEDTIME))


(deftrap _SETTIMEBASEZERO ((TB (:POINTER :TIMEBASERECORD)) (ZERO (:POINTER :TIMERECORD)))
   NIL
   (:STACK-TRAP #xAAAA :D0 296 TB ZERO))

;   CallBack Routines  

(deftrap _NEWCALLBACK ((TB (:POINTER :TIMEBASERECORD)) (CBTYPE :SIGNED-INTEGER))
   (:STACK (:POINTER :CALLBACKRECORD))
   (:STACK-TRAP #xAAAA :D0 235 TB CBTYPE))


(deftrap _DISPOSECALLBACK ((QTCALL (:POINTER :CALLBACKRECORD)))
   NIL
   (:STACK-TRAP #xAAAA :D0 236 QTCALL))


(deftrap _GETCALLBACKTYPE ((QTCALL (:POINTER :CALLBACKRECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 237 QTCALL))

(deftrap _GETCALLBACKTIMEBASE ((QTCALL (:POINTER :CALLBACKRECORD)))
   (:STACK (:POINTER :TIMEBASERECORD))
   (:STACK-TRAP #xAAAA :D0 238 QTCALL))


(deftrap _CALLMEWHEN ((QTCALL (:POINTER :CALLBACKRECORD)) (CALLBACKPROC :POINTER) (REFCON :SIGNED-LONG) (PARAM1 :SIGNED-LONG) (PARAM2 :SIGNED-LONG) (PARAM3 :SIGNED-LONG))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 184 QTCALL CALLBACKPROC REFCON PARAM1 PARAM2 PARAM3))


(deftrap _CANCELCALLBACK ((CB (:POINTER :CALLBACKRECORD)))
   NIL
   (:STACK-TRAP #xAAAA :D0 185 CB))

;   Clock CallBack support Routines  

(deftrap _ADDCALLBACKTOTIMEBASE ((CB (:POINTER :CALLBACKRECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 297 CB))

(deftrap _REMOVECALLBACKFROMTIMEBASE ((CB (:POINTER :CALLBACKRECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAAA :D0 298 CB))

(deftrap _GETFIRSTCALLBACK ((TB (:POINTER :TIMEBASERECORD)))
   (:STACK (:POINTER :CALLBACKRECORD))
   (:STACK-TRAP #xAAAA :D0 299 TB))

(deftrap _GETNEXTCALLBACK ((CB (:POINTER :CALLBACKRECORD)))
   (:STACK (:POINTER :CALLBACKRECORD))
   (:STACK-TRAP #xAAAA :D0 300 CB))

(deftrap _EXECUTECALLBACK ((CB (:POINTER :CALLBACKRECORD)))
   NIL
   (:STACK-TRAP #xAAAA :D0 301 CB))

;  Movie Controller Routines 
(defconstant $MovieControllerComponentType :|play|)

(defconstant $mcActionIdle 1)
(defconstant $mcActionDraw 2)
(defconstant $mcActionActivate 3)
(defconstant $mcActionDeactivate 4)
(defconstant $mcActionMouseDown 5)
(defconstant $mcActionKey 6)
(defconstant $mcActionPlay 8)
(defconstant $mcActionGoToTime 12)
(defconstant $mcActionSetVolume 14)
(defconstant $mcActionGetVolume 15)
(defconstant $mcActionStep 18)
(defconstant $mcActionSetLooping 21)
(defconstant $mcActionGetLooping 22)
(defconstant $mcActionSetLoopIsPalindrome 23)
(defconstant $mcActionGetLoopIsPalindrome 24)
(defconstant $mcActionSetGrowBoxBounds 25)
(defconstant $mcActionControllerSizeChanged 26)
(defconstant $mcActionSetSelectionBegin 29)
(defconstant $mcActionSetSelectionDuration 30)
(defconstant $mcActionSetPosterTime 31)
(defconstant $mcActionSetKeysEnabled 32)
(defconstant $mcActionGetKeysEnabled 33)
(defconstant $mcActionSetPlaySelection 34)
(defconstant $mcActionGetPlaySelection 35)
(defconstant $mcActionSetUseBadge 36)
(defconstant $mcActionGetUseBadge 37)
(defconstant $mcActionSetFlags 38)
(defconstant $mcActionGetFlags 39)
(defconstant $mcActionSetPlayEveryFrame 40)
(defconstant $mcActionGetPlayEveryFrame 41)
(defconstant $mcActionGetPlayRate 42)
(defconstant $mcActionShowBalloon 43)
(defconstant $mcActionBadgeClick 44)

(def-mactype :MCACTION (find-mactype :SIGNED-INTEGER))
(def-mactype :MCACTIONFILTER (find-mactype :POINTER))

(defconstant $mcTopLeftMovie #X1)
(defconstant $mcScaleMovieToFit #X2)
(defconstant $mcWithBadge #X4)
(defconstant $mcNotVisible #X8)
(defconstant $mcWithFrame #X10)
(defconstant $mcInfoUndoAvailable #X1)
(defconstant $mcInfoCutAvailable #X2)
(defconstant $mcInfoCopyAvailable #X4)
(defconstant $mcInfoPasteAvailable #X8)
(defconstant $mcInfoClearAvailable #X10)
(defconstant $mcInfoHasSound #X20)
(defconstant $mcInfoIsPlaying #X40)
(defconstant $mcInfoIsLooping #X80)
(defconstant $mcInfoIsInPalindrome #X100)
(defconstant $mcInfoEditingEnabled #X200)

;   target management  

(deftrap _NEWMOVIECONTROLLER ((M (:POINTER :MOVIERECORD)) (MOVIERECT :RECT) (CONTROLLERCREATIONFLAGS :SIGNED-LONG))
   (:STACK (:POINTER :COMPONENTINSTANCERECORD))
   (:STACK-TRAP #xAAAA :D0 394 M MOVIERECT CONTROLLERCREATIONFLAGS))

(deftrap _DISPOSEMOVIECONTROLLER ((MC (:POINTER :COMPONENTINSTANCERECORD)))
   NIL
   (:STACK-TRAP #xAAAA :D0 395 MC))


(deftrap _MCSETMOVIE ((MC (:POINTER :COMPONENTINSTANCERECORD)) (M (:POINTER :MOVIERECORD)) (MOVIEWINDOW (:POINTER :GRAFPORT)) (WHERE :POINT))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC M MOVIEWINDOW WHERE ((+ (ASH 12 16) 2) :SIGNED-LONGINT)))

; Not in ROM - INLINE =  #x4267 #x2F3C #x0002 #x0005 #x7000 #xA82A
; Translated by hand
(deftrap _MCGETMOVIE ((MC (:POINTER :COMPONENTINSTANCERECORD)))
   (:STACK (:POINTER :MOVIERECORD))
   (:STACK-TRAP #xa82a :d0 0 MC (0 :integer) (#x20005 :signed-long)))

(deftrap _MCREMOVEMOVIE ((MC (:POINTER :COMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC ((+ (ASH 0 16) 6) :SIGNED-LONGINT)))

;   event handling etc.  

(deftrap _MCISPLAYEREVENT ((MC (:POINTER :COMPONENTINSTANCERECORD)) (E :EVENTRECORD))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC E ((+ (ASH 4 16) 7) :SIGNED-LONGINT)))

(deftrap _MCSETACTIONFILTER ((MC (:POINTER :COMPONENTINSTANCERECORD)) (FILTER :POINTER))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC FILTER ((+ (ASH 4 16) 8) :SIGNED-LONGINT)))

(deftrap _MCDOACTION ((MC (:POINTER :COMPONENTINSTANCERECORD)) (ACTION :SIGNED-INTEGER) (PARAMS :POINTER))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC ACTION PARAMS ((+ (ASH 6 16) 9) :SIGNED-LONGINT)))

;   state type things  

(deftrap _MCSETCONTROLLERATTACHED ((MC (:POINTER :COMPONENTINSTANCERECORD)) (ATTACH :BOOLEAN))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC ATTACH ((+ (ASH 2 16) 10) :SIGNED-LONGINT)))

(deftrap _MCISCONTROLLERATTACHED ((MC (:POINTER :COMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC ((+ (ASH 0 16) 11) :SIGNED-LONGINT)))

(deftrap _MCSETCONTROLLERPORT ((MC (:POINTER :COMPONENTINSTANCERECORD)) (GP (:POINTER :CGRAFPORT)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC GP ((+ (ASH 4 16) 12) :SIGNED-LONGINT)))

(deftrap _MCGETCONTROLLERPORT ((MC (:POINTER :COMPONENTINSTANCERECORD)))
   (:STACK (:POINTER :CGRAFPORT))
   (:STACK-TRAP #xA82A :D0 0 MC ((+ (ASH 0 16) 13) :SIGNED-LONGINT)))


(deftrap _MCSETVISIBLE ((MC (:POINTER :COMPONENTINSTANCERECORD)) (SHOW :BOOLEAN))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC SHOW ((+ (ASH 2 16) 14) :SIGNED-LONGINT)))

(deftrap _MCGETVISIBLE ((MC (:POINTER :COMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC ((+ (ASH 0 16) 15) :SIGNED-LONGINT)))


(deftrap _MCGETCONTROLLERBOUNDSRECT ((MC (:POINTER :COMPONENTINSTANCERECORD)) (BOUNDS (:POINTER :RECT)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC BOUNDS ((+ (ASH 4 16) 16) :SIGNED-LONGINT)))

(deftrap _MCSETCONTROLLERBOUNDSRECT ((MC (:POINTER :COMPONENTINSTANCERECORD)) (BOUNDS :RECT))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC BOUNDS ((+ (ASH 4 16) 17) :SIGNED-LONGINT)))

(deftrap _MCGETCONTROLLERBOUNDSRGN ((MC (:POINTER :COMPONENTINSTANCERECORD)))
   (:STACK (:HANDLE :REGION))
   (:STACK-TRAP #xA82A :D0 0 MC ((+ (ASH 0 16) 18) :SIGNED-LONGINT)))

(deftrap _MCGETWINDOWRGN ((MC (:POINTER :COMPONENTINSTANCERECORD)) (W (:POINTER :GRAFPORT)))
   (:STACK (:HANDLE :REGION))
   (:STACK-TRAP #xA82A :D0 0 MC W ((+ (ASH 4 16) 19) :SIGNED-LONGINT)))

;   other stuff  

(deftrap _MCMOVIECHANGED ((MC (:POINTER :COMPONENTINSTANCERECORD)) (M (:POINTER :MOVIERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC M ((+ (ASH 4 16) 20) :SIGNED-LONGINT)))

(deftrap _MCSETDURATION ((MC (:POINTER :COMPONENTINSTANCERECORD)) (DURATION :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC DURATION ((+ (ASH 4 16) 21) :SIGNED-LONGINT)))

(deftrap _MCGETCURRENTTIME ((MC (:POINTER :COMPONENTINSTANCERECORD)) (SCALE (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC SCALE ((+ (ASH 4 16) 22) :SIGNED-LONGINT)))

(deftrap _MCNEWATTACHEDCONTROLLER ((MC (:POINTER :COMPONENTINSTANCERECORD)) (M (:POINTER :MOVIERECORD)) (W (:POINTER :GRAFPORT)) (WHERE :POINT))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC M W WHERE ((+ (ASH 12 16) 23) :SIGNED-LONGINT)))

(deftrap _MCPOSITIONCONTROLLER ((MC (:POINTER :COMPONENTINSTANCERECORD)) (MOVIERECT (:POINTER :RECT)) (CONTROLLERRECT (:POINTER :RECT)) (CONTROLLERCREATIONFLAGS :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC MOVIERECT CONTROLLERRECT CONTROLLERCREATIONFLAGS ((+ (ASH 12 16) 36) :SIGNED-LONGINT)))

;   direct event handlers  

(deftrap _MCDRAW ((MC (:POINTER :COMPONENTINSTANCERECORD)) (W (:POINTER :GRAFPORT)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC W ((+ (ASH 4 16) 24) :SIGNED-LONGINT)))

(deftrap _MCACTIVATE ((MC (:POINTER :COMPONENTINSTANCERECORD)) (W (:POINTER :GRAFPORT)) (ACTIVATE :BOOLEAN))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC W ACTIVATE ((+ (ASH 6 16) 25) :SIGNED-LONGINT)))

(deftrap _MCIDLE ((MC (:POINTER :COMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC ((+ (ASH 0 16) 26) :SIGNED-LONGINT)))

(deftrap _MCKEY ((MC (:POINTER :COMPONENTINSTANCERECORD)) (KEY :UNSIGNED-BYTE) (MODIFIERS :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC KEY MODIFIERS ((+ (ASH 6 16) 27) :SIGNED-LONGINT)))

(deftrap _MCCLICK ((MC (:POINTER :COMPONENTINSTANCERECORD)) (W (:POINTER :GRAFPORT)) (WHERE :POINT) (WHEN :SIGNED-LONG) (MODIFIERS :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC W WHERE WHEN MODIFIERS ((+ (ASH 16 16) 28) :SIGNED-LONGINT)))

;    calls for editing  

(deftrap _MCENABLEEDITING ((MC (:POINTER :COMPONENTINSTANCERECORD)) (ENABLED :BOOLEAN))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC ENABLED ((+ (ASH 2 16) 29) :SIGNED-LONGINT)))

(deftrap _MCISEDITINGENABLED ((MC (:POINTER :COMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC ((+ (ASH 0 16) 30) :SIGNED-LONGINT)))

(deftrap _MCCOPY ((MC (:POINTER :COMPONENTINSTANCERECORD)))
   (:STACK (:POINTER :MOVIERECORD))
   (:STACK-TRAP #xA82A :D0 0 MC ((+ (ASH 0 16) 31) :SIGNED-LONGINT)))

(deftrap _MCCUT ((MC (:POINTER :COMPONENTINSTANCERECORD)))
   (:STACK (:POINTER :MOVIERECORD))
   (:STACK-TRAP #xA82A :D0 0 MC ((+ (ASH 0 16) 32) :SIGNED-LONGINT)))

(deftrap _MCPASTE ((MC (:POINTER :COMPONENTINSTANCERECORD)) (SRCMOVIE (:POINTER :MOVIERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC SRCMOVIE ((+ (ASH 4 16) 33) :SIGNED-LONGINT)))

(deftrap _MCCLEAR ((MC (:POINTER :COMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC ((+ (ASH 0 16) 34) :SIGNED-LONGINT)))

(deftrap _MCUNDO ((MC (:POINTER :COMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC ((+ (ASH 0 16) 35) :SIGNED-LONGINT)))

;   menu related stuff  

(deftrap _MCGETCONTROLLERINFO ((MC (:POINTER :COMPONENTINSTANCERECORD)) (MCINFOFLAGS (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC MCINFOFLAGS ((+ (ASH 4 16) 37) :SIGNED-LONGINT)))


(deftrap _MCSETCLIP ((MC (:POINTER :COMPONENTINSTANCERECORD)) (THECLIP (:HANDLE :REGION)) (MOVIECLIP (:HANDLE :REGION)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC THECLIP MOVIECLIP ((+ (ASH 8 16) 40) :SIGNED-LONGINT)))

(deftrap _MCGETCLIP ((MC (:POINTER :COMPONENTINSTANCERECORD)) (THECLIP (:POINTER (:HANDLE :REGION))) (MOVIECLIP (:POINTER (:HANDLE :REGION))))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC THECLIP MOVIECLIP ((+ (ASH 8 16) 41) :SIGNED-LONGINT)))


(deftrap _MCDRAWBADGE ((MC (:POINTER :COMPONENTINSTANCERECORD)) (MOVIERGN (:HANDLE :REGION)) (BADGERGN (:POINTER (:HANDLE :REGION))))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 MC MOVIERGN BADGERGN ((+ (ASH 8 16) 42) :SIGNED-LONGINT)))

;  movie controller error codes 
(defconstant $cannotMoveAttachedController -9999)
(defconstant $controllerHasFixedHeight -9998)
(defconstant $cannotSetWidthOfAttachedController -9997)
(defconstant $controllerBoundsNotExact -9996)
(defconstant $editingNotAllowed -9995)
(defconstant $badControllerHeight -9994)

;  movie controller routine selectors 
(defconstant $kMCSetMovieSelect 2)
(defconstant $kMCRemoveMovieSelect 3)
(defconstant $kMCIsPlayerEventSelect 7)
(defconstant $kMCSetActionFilterSelect 8)
(defconstant $kMCDoActionSelect 9)
(defconstant $kMCSetControllerAttachedSelect 10)
(defconstant $kMCIsControllerAttachedSelect 11)
(defconstant $kMCSetControllerPortSelect 12)
(defconstant $kMCGetControllerPortSelect 13)
(defconstant $kMCGetVisibleSelect 14)
(defconstant $kMCSetVisibleSelect 15)
(defconstant $kMCGetControllerBoundsRectSelect 16)
(defconstant $kMCSetControllerBoundsRectSelect 17)
(defconstant $kMCGetControllerBoundsRgnSelect 18)
(defconstant $kMCGetWindowRgnSelect 19)
(defconstant $kMCMovieChangedSelect 20)
(defconstant $kMCSetDurationSelect 21)
(defconstant $kMCGetCurrentTimeSelect 22)
(defconstant $kMCNewAttachedControllerSelect 23)
(defconstant $kMCDrawSelect 24)
(defconstant $kMCActivateSelect 25)
(defconstant $kMCIdleSelect 26)
(defconstant $kMCKeySelect 27)
(defconstant $kMCClickSelect 28)
(defconstant $kMCEnableEditingSelect 29)
(defconstant $kMCIsEditingEnabledSelect 30)
(defconstant $kMCCopySelect 31)
(defconstant $kMCCutSelect 32)
(defconstant $kMCPasteSelect 33)
(defconstant $kMCClearSelect 34)
(defconstant $kMCUndoSelect 35)
(defconstant $kMCPositionControllerSelect 36)
(defconstant $kMCGetControllerInfoSelect 37)
(defconstant $kMCNewControllerFromFileSelect 38)
(defconstant $kMCSetBadgePictSelect 39)
(defconstant $kMCSetClipSelect 40)
(defconstant $kMCGetClipSelect 41)
(defconstant $kMCDrawBadgeSelect 42)

; $ENDC                         ;  UsingMovies 

; $IFC NOT UsingIncludes

; $ENDC


(export '($KMCDRAWBADGESELECT $KMCGETCLIPSELECT $KMCSETCLIPSELECT
          $KMCSETBADGEPICTSELECT $KMCNEWCONTROLLERFROMFILESELECT
          $KMCGETCONTROLLERINFOSELECT $KMCPOSITIONCONTROLLERSELECT
          $KMCUNDOSELECT $KMCCLEARSELECT $KMCPASTESELECT $KMCCUTSELECT
          $KMCCOPYSELECT $KMCISEDITINGENABLEDSELECT $KMCENABLEEDITINGSELECT
          $KMCCLICKSELECT $KMCKEYSELECT $KMCIDLESELECT $KMCACTIVATESELECT
          $KMCDRAWSELECT $KMCNEWATTACHEDCONTROLLERSELECT
          $KMCGETCURRENTTIMESELECT $KMCSETDURATIONSELECT $KMCMOVIECHANGEDSELECT
          $KMCGETWINDOWRGNSELECT $KMCGETCONTROLLERBOUNDSRGNSELECT
          $KMCSETCONTROLLERBOUNDSRECTSELECT $KMCGETCONTROLLERBOUNDSRECTSELECT
          $KMCSETVISIBLESELECT $KMCGETVISIBLESELECT $KMCGETCONTROLLERPORTSELECT
          $KMCSETCONTROLLERPORTSELECT $KMCISCONTROLLERATTACHEDSELECT
          $KMCSETCONTROLLERATTACHEDSELECT $KMCDOACTIONSELECT
          $KMCSETACTIONFILTERSELECT $KMCISPLAYEREVENTSELECT
          $KMCREMOVEMOVIESELECT $KMCSETMOVIESELECT $BADCONTROLLERHEIGHT
          $EDITINGNOTALLOWED $CONTROLLERBOUNDSNOTEXACT
          $CANNOTSETWIDTHOFATTACHEDCONTROLLER $CONTROLLERHASFIXEDHEIGHT
          $CANNOTMOVEATTACHEDCONTROLLER $MCINFOEDITINGENABLED
          $MCINFOISINPALINDROME $MCINFOISLOOPING $MCINFOISPLAYING
          $MCINFOHASSOUND $MCINFOCLEARAVAILABLE $MCINFOPASTEAVAILABLE
          $MCINFOCOPYAVAILABLE $MCINFOCUTAVAILABLE $MCINFOUNDOAVAILABLE
          $MCWITHFRAME $MCNOTVISIBLE $MCWITHBADGE $MCSCALEMOVIETOFIT
          $MCTOPLEFTMOVIE $MCACTIONBADGECLICK $MCACTIONSHOWBALLOON
          $MCACTIONGETPLAYRATE $MCACTIONGETPLAYEVERYFRAME
          $MCACTIONSETPLAYEVERYFRAME $MCACTIONGETFLAGS $MCACTIONSETFLAGS
          $MCACTIONGETUSEBADGE $MCACTIONSETUSEBADGE $MCACTIONGETPLAYSELECTION
          $MCACTIONSETPLAYSELECTION $MCACTIONGETKEYSENABLED
          $MCACTIONSETKEYSENABLED $MCACTIONSETPOSTERTIME
          $MCACTIONSETSELECTIONDURATION $MCACTIONSETSELECTIONBEGIN
          $MCACTIONCONTROLLERSIZECHANGED $MCACTIONSETGROWBOXBOUNDS
          $MCACTIONGETLOOPISPALINDROME $MCACTIONSETLOOPISPALINDROME
          $MCACTIONGETLOOPING $MCACTIONSETLOOPING $MCACTIONSTEP
          $MCACTIONGETVOLUME $MCACTIONSETVOLUME $MCACTIONGOTOTIME $MCACTIONPLAY
          $MCACTIONKEY $MCACTIONMOUSEDOWN $MCACTIONDEACTIVATE $MCACTIONACTIVATE
          $MCACTIONDRAW $MCACTIONIDLE $MOVIECONTROLLERCOMPONENTTYPE
          $QTCBNEEDSTIMECHANGES $QTCBNEEDSRATECHANGES $CALLBACKATINTERRUPT
          $CALLBACKATTIMEJUMP $CALLBACKATRATE $CALLBACKATTIME
          $TIMEBASEAFTERSTOPTIME $TIMEBASEBEFORESTARTTIME $TRIGGERRATECHANGE
          $TRIGGERRATENOTEQUAL $TRIGGERRATEGTE $TRIGGERRATELTE
          $TRIGGERRATEEQUAL $TRIGGERRATEGT $TRIGGERRATELT $TRIGGERTIMEEITHER
          $TRIGGERTIMEBWD $TRIGGERTIMEFWD $LOOPTIMEBASE $FEATUREUNSUPPORTED
          $COULDNOTUSEANEXISTINGSAMPLE $NODEFAULTDATAREF $BADDATAREFINDEX
          $INVALIDDATAREFCONTAINER $NOMOVIEFOUND $DATANODATAREF
          $ENDOFDATAREACHED $DATAALREADYCLOSED $DATAALREADYOPENFORWRITE
          $DATANOTOPENFORWRITE $DATANOTOPENFORREAD $INVALIDSAMPLEDESCRIPTION
          $INVALIDCHUNKCACHE $INVALIDSAMPLEDESCINDEX $INVALIDCHUNKNUM
          $INVALIDSAMPLENUM $INVALIDRECT $CANTENABLETRACK
          $INTERNALQUICKTIMEERROR $BADEDITINDEX $TIMENOTINMEDIA $TIMENOTINTRACK
          $TRACKNOTINMOVIE $TRACKIDNOTFOUND $BADTRACKINDEX
          $MAXSIZETOGROWTOOSMALL $USERDATAITEMNOTFOUND $STALEEDITSTATE
          $NONMATCHINGEDITSTATE $INVALIDEDITSTATE $CANTCREATESINGLEFORKFILE
          $WFFILENOTFOUND $MOVIETOOLBOXUNITIALIZED $PROGRESSPROCABORTED
          $MEDIATYPESDONTMATCH $BADEDITLIST $CANTPUTPUBLICMOVIEATOM
          $INVALIDTIME $INVALIDDURATION $INVALIDHANDLER $INVALIDDATAREF
          $INVALIDSAMPLETABLE $INVALIDMOVIE $INVALIDTRACK $INVALIDMEDIA
          $NODATAHANDLER $NOMEDIAHANDLER $BADCOMPONENTTYPE $CANTOPENHANDLER
          $CANTFINDHANDLER $BADPUBLICMOVIEATOM $BADIMAGEDESCRIPTION
          $COULDNOTRESOLVEDATAREF $MOVIEINDATAFORKRESID $DATAREFWASNOTRESOLVED
          $DATAREFSELFREFERENCE $HINTSSCRUBMODE $MOVIESCRAPONLYPUTMOVIE
          $MOVIESCRAPDONTZEROSCRAP $FLATTENDONTINTERLEAVEFLATTEN
          $FLATTENACTIVETRACKSONLY $FLATTENADDMOVIETODATAFORK
          $CREATEMOVIEFILEDONTOPENFILE $CREATEMOVIEFILEDONTCREATEMOVIE
          $CREATEMOVIEFILEDELETECURFILE $NEXTTIMEIGNOREACTIVESEGMENT
          $NEXTTIMEEDGEOK $NEXTTIMESYNCSAMPLE $NEXTTIMETRACKEDIT
          $NEXTTIMEMEDIAEDIT $NEXTTIMEMEDIASAMPLE $MEDIASAMPLENOTSYNC
          $TRACKUSAGEINPOSTER $TRACKUSAGEINPREVIEW $TRACKUSAGEINMOVIE
          $NEWMOVIEDONTASKUNRESOLVEDDATAREFS $NEWMOVIEDONTRESOLVEDATAREFS
          $NEWMOVIEACTIVE $MEDIAQUALITYBEST $MEDIAQUALITYBETTER
          $MEDIAQUALITYNORMAL $MEDIAQUALITYDRAFT $PROGRESSOPLOADMEDIAINTORAM
          $PROGRESSOPLOADTRACKINTORAM $PROGRESSOPLOADMOVIEINTORAM
          $PROGRESSOPCUT $PROGRESSOPCOPY $PROGRESSOPADDMOVIESELECTION
          $PROGRESSOPPASTE $PROGRESSOPINSERTMOVIESEGMENT
          $PROGRESSOPINSERTTRACKSEGMENT $PROGRESSOPFLATTEN $MOVIEPROGRESSCLOSE
          $MOVIEPROGRESSUPDATEPERCENT $MOVIEPROGRESSOPEN $KNOVOLUME
          $KFULLVOLUME $DOTHERIGHTTHING $SOUNDMEDIATYPE $VIDEOMEDIATYPE
          $MOVIEFILETYPE $GESTALTQUICKTIME))
(provide-interface 'Movies)