#-------------------------------------------------------------------------------------------
#
#	Program:	< DMZ 1.3 >
#	File:		< dmz.make >
#	
#	by Pete Helme
#	of <Apple Macintosh Developer Technical Support - or wheverever>
#
#	Modification History
#	5/23/94	 rrk	Implemented changes for compatibility with PPC
#	
#-------------------------------------------------------------------------------------------

PPC				=	PPCC -w conformance -appleext on

SymOptions		=	-sym full

OptOptions		=	-opt off

PPCOptions		=	{IncludeFolders} {SymOptions} {OptOptions}


COptions		= {SymOptions} # -d useDump -d path=""{CIncludes}myIncludes.dump""

AOptions		= {SymOptions}

LinkOptions 	= {SymOptions} -w

CObjs			=	dmzMain.c.o 
					dmzLists.c.o 
					dmzAT.c.o
					
CSysObjs		= 	"{Libraries}"Runtime.o 
					"{CLibraries}"StdCLib.o 
					"{Libraries}"ToolLibs.o 
					"{Libraries}"Interface.o


AObjs			= 	dmz.a.o

PPCObjs			=	dmzMain.o 
					dmzLists.o 
					dmzAT.o

PPCSysObjs		=	"{PPCLibraries}"InterfaceLib.xcoff 
					"{PPCLibraries}"MathLib.xcoff 
					"{PPCLibraries}"StdCLib.xcoff 
					"{PPCLibraries}"StdCRuntime.o 
					"{PPCLibraries}"PPCCRuntime.o



CLDEFObjs		=	dmzLDEF.c.o 
					"{Libraries}"Interface.o

dmz			dmz.r dmz.h dmz.make SktListener.rsrc
			Rez -rd -o {Targ} dmz.r -append

dmz			{CObjs} dmz.make dmz.a.o
			Link {LinkOptions} {CObjs} {CSysObjs} dmz.a.o  -o {Targ}
			Rez dmz.r -append -o dmz
			SetFile {Targ} -t APPL -c 'MOOS' -a B

dmz.a.o  dmz.a 
			asm {AOptions} dmz.a
			
dmzAT.c.o  dmzAT.c dmz.h
			C {COptions} dmzAT.c
	
dmzLists.c.o  dmzLists.c dmz.h
			C {COptions} dmzLists.c

dmzMain.c.o  dmzMain.c dmz.h
			C {COptions} dmzMain.c



SktListener.rsrc  SktListener.a.o dmz.make
				link -o SktListener.rsrc -t rsrc -c RSED 
				SktListener.a.o -rt Sock=128 
				-m THE_LISTENER -ra locked
				
SktListener.a.o  SktListener.a dmz.make
			asm {AOptions} SktListener.a -o SktListener.a.o
		
dmz			{CLDEFObjs} dmz.make
		Link -m MAIN -rt LDEF=128 -ra Main=resLocked -o dmzLDEF.rsrc {CLDEFObjs}
		DeRez dmzLDEF.rsrc > dmzLDEF.r
		Rez dmzLDEF.r -rd -o {Targ} -append
	

dmz			{PPCObjs} dmz.make
		PPCLink {PPCObjs} {PPCSysObjs} {SymOptions} -main __start -o dmz.xcoff
		makepef dmz.xcoff -o dmz 
		-l InterfaceLib.xcoff=InterfaceLib 
		-l MathLib.xcoff=MathLib 
		-l StdCLib.xcoff=StdCLib 
		-ft APPL -fc '????'
		IF "{SymOptions}" != "-sym off"
			MakeSYM		dmz.xcoff
		END
		# Set file's creator type, turn on bundle bit, turn off inited bit
		SetFile dmz -t APPL -c 'MOOS' -a Bi

dmzAT.o  dmzAT.c dmz.h
	{PPC} {PPCOptions} dmzAT.c -o dmzAT.o
	
dmzLists.o  dmzLists.c dmz.h
	{PPC} {PPCOptions} dmzLists.c -o dmzLists.o

dmzMain.o  dmzMain.c dmz.h
	{PPC} {PPCOptions} dmzMain.c -o dmzMain.o
